/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import objectes.assignatura;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 *
 * @author z0rskrab
 */
public class bdd_assignatures {


    public static boolean insertAssignatura(connect con, assignatura a) {
        try {
            String sql="insert into t_assignatures(t_assignatura_nom) values(?)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql,Statement.RETURN_GENERATED_KEYS);
            pStmt.setString(1, a.getNom());
            int rs=pStmt.executeUpdate();
            ResultSet resultSet=pStmt.getGeneratedKeys();
            if (resultSet != null && resultSet.next () ){
                int id=resultSet.getInt(1);
                String sql_tipos="insert into t_assignatures_tipologia(t_assignatura_id,t_tipologia_id) select ?,0 union all select ?,1 union all select ?,2 union select ?,3";
                PreparedStatement pStmt_tipos=con.getConn().prepareStatement(sql_tipos);
                pStmt_tipos.setInt(1, id);
                pStmt_tipos.setInt(2, id);
                pStmt_tipos.setInt(3, id);
                pStmt_tipos.setInt(4, id);
                int rsbis=pStmt_tipos.executeUpdate();
            }
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }

    public static boolean updateAssignatura(connect con, assignatura a) {
        try {
            String sql="update t_assignatures set t_assignatura_nom=?, t_assignatura_ncredits=? where t_assignatura_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setString(1, a.getNom());
            pStmt.setInt(2, a.getnCredits());
            pStmt.setInt(3, a.getId());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }


    public static Object[] selectAll(connect con) {
        Statement stmt=null;
        assignatura[] assignatures=null;
        assignatura aux;
        try {
            String sql="select * from t_assignatures";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            //ResultSet rs=stmt.executeQuery("select * from t_assignatures");
            rs.last();
            int nreg=rs.getRow();
            assignatures=new assignatura[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignatura(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_assignatura_ncredits"));
                assignatures[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignatures;
    }

    public static void deleteAssignatura(connect con, assignatura a) {
        try {
            String sql_hg="delete from t_horaris_grups where t_assignatura_id=?";
            String sql_atg="delete from t_assignatures_tipologia_grup where t_assignatura_id=?";
            String sql_at="delete from t_assignatures_tipologia where t_assignatura_id=?";
            String sql_a="delete from t_assignatures where t_assignatura_id=?";
            String sql_c="delete from t_capacitacions where t_assignatura_id=?";
            PreparedStatement pStmt_hg=con.getConn().prepareStatement(sql_hg);
            PreparedStatement pStmt_atg=con.getConn().prepareStatement(sql_atg);
            PreparedStatement pStmt_at=con.getConn().prepareStatement(sql_at);
            PreparedStatement pStmt_a=con.getConn().prepareStatement(sql_a);
            PreparedStatement pStmt_c=con.getConn().prepareStatement(sql_c);
            pStmt_hg.setInt(1, a.getId());
            pStmt_atg.setInt(1, a.getId());
            pStmt_at.setInt(1, a.getId());
            pStmt_a.setInt(1, a.getId());
            pStmt_c.setInt(1, a.getId());
            int rs_hg=pStmt_hg.executeUpdate();
            int rs_atg=pStmt_atg.executeUpdate();
            int rs_at=pStmt_at.executeUpdate();
            int rs_a=pStmt_a.executeUpdate();
            int rs_c=pStmt_c.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


}
