/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.ResultSet;
import java.util.HashSet;
import objectes.assignatura;
import objectes.assignaturaTipologia;
import objectes.professor;

/**
 *
 * @author z0rskrab
 */
public class bdd_capacitacions {
    public static boolean addProfessors(connect con, Object[] p, int idAssignatura, int idTipologia) {
        //Statement stmt=null;
        try {
            //stmt=con.newStatement();
            int nProfessors=p.length,i;
            String sql="INSERT INTO t_capacitacions(t_professor_id,t_assignatura_id,t_assignatura_tipologia_id) SELECT ?,?,?";
            //String union="INSERT INTO t_capacitacions(t_professor_id,t_assignatura_id,t_assignatura_tipologia_id) SELECT "+((professor)p[0]).getId()+","+idAssignatura+","+idTipologia;
            if (nProfessors>0) {
                for (i=1;i<nProfessors;i++) {
                    sql+=" UNION ALL SELECT ?,?,?";
                    //union+=" UNION ALL SELECT "+((professor)p[i]).getId()+","+idAssignatura+","+idTipologia;
                }
            }
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            for (i=0;i<nProfessors;i++) {
                pStmt.setInt(i*3+1,((professor)p[i]).getId());
                pStmt.setInt(i*3+2,idAssignatura);
                pStmt.setInt(i*3+3,idTipologia);
            }
            int rs=pStmt.executeUpdate();
//            int rs=stmt.executeUpdate(union);
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }

    public static boolean addProfessors(connect con, Object[] p, int idAssignatura) {
        try {
            int nProfessors=p.length,i;
            //String union_profs="";
            //String union="select t_professor_id, t_assignatura_id, t_tipologia_id from t_professors, t_assignatures_tipologia where t_assignatura_id="+idAssignatura+" and t_assignatura_tipologia_ncredits>0 ";
            if (nProfessors>0) {
                String sql="insert ignore into t_capacitacions(t_professor_id,t_assignatura_id,t_assignatura_tipologia_id) select t_professor_id, t_assignatura_id, t_tipologia_id from t_professors, t_assignatures_tipologia where t_assignatura_id=? and t_assignatura_tipologia_ncredits>0 and (t_professor_id=? ";
                //union_profs=" and ( t_professor_id="+((professor)p[0]).getId();
                for (i=1;i<nProfessors;i++) {
                       //union_profs+=" or t_professor_id="+((professor)p[i]).getId();
                       sql+=" or t_professor_id=?";
                }
                sql+=" )";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idAssignatura);
                for (i=0;i<nProfessors;i++) {
                    pStmt.setInt(i+2,((professor)p[i]).getId());
                }
                int rs=pStmt.executeUpdate();
            }

            //int rs=stmt.executeUpdate("insert ignore into t_capacitacions(t_professor_id,t_assignatura_id,t_assignatura_tipologia_id) "+union+union_profs);
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }

    public static boolean deleteProfessor(connect con, professor p, assignaturaTipologia a) {
        try {
            String sql="DELETE from t_capacitacions where t_assignatura_id=? and t_assignatura_tipologia_id=? and t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, a.getId());
            pStmt.setInt(2, a.getTipologia());
            pStmt.setInt(3, p.getId());
            //String union="DELETE from t_capacitacions where t_assignatura_id="+a.getId()+" and t_assignatura_tipologia_id="+a.getTipologia()+" and t_professor_id="+p.getId();
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }

    public static assignaturaTipologia[] getCapacitacions(connect con, professor p) {
        assignaturaTipologia[] solucio = null;
        assignaturaTipologia aux;
        try {
            String sql="SELECT * from t_capacitacions, t_assignatures where t_capacitacions.t_assignatura_id=t_assignatures.t_assignatura_id and t_professor_id=? order by t_assignatures.t_assignatura_id, t_capacitacions.t_assignatura_tipologia_id";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, p.getId());
            //String union="SELECT * from t_capacitacions, t_assignatures where t_capacitacions.t_assignatura_id=t_assignatures.t_assignatura_id and t_professor_id="+p.getId()+" order by t_assignatures.t_assignatura_id, t_capacitacions.t_assignatura_tipologia_id";
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            solucio=new assignaturaTipologia[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologia(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_assignatura_tipologia_id"));
                solucio[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
        }
        return solucio;
    }

    public static String getTaulaCapacitacions(connect con) {
        String capacitacions=null;
        try {
            String sql = "select * from t_capacitacions";
            PreparedStatement pStmt = con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            HashSet<String> capacitats=new HashSet<String>();
            while (rs.next()) {
                 capacitats.add((rs.getInt("t_assignatura_id") + "#" + rs.getInt("t_professor_id") + "@" + rs.getInt("t_assignatura_tipologia_id")));
            }
            sql="select t_professor_id, t_assignatura_id, t_tipologia_id, t_grup_id from t_professors,t_assignatures_tipologia_grup order by t_professor_id, t_assignatura_id, t_tipologia_id, t_grup_id";
            pStmt=con.getConn().prepareStatement(sql);
            rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            rs.beforeFirst();
            capacitacions="[";
            professor paux=new professor(0,"","");
            while (rs.next()) {
                String aux=rs.getInt("t_assignatura_id") + "#" + rs.getInt("t_professor_id") + "@" + rs.getInt("t_tipologia_id");
                professor actual=new professor(rs.getInt("t_professor_id"),"","");
                if (capacitats.contains(aux)) {
                    if (!actual.equals(paux)) {
                        capacitacions=capacitacions.substring(0, capacitacions.length()-1)+"|1,";
                        paux.setId(actual.getId());
                    } else {
                        capacitacions+="1,";
                    }
                } else {
                    if (!actual.equals(paux)) {
                        capacitacions=capacitacions.substring(0, capacitacions.length()-1)+"|0,";
                        paux.setId(actual.getId());
                    } else {
                        capacitacions+="0,";
                    }

                }


            }
            capacitacions="["+capacitacions.substring(0, capacitacions.length()-1)+"|]";
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
        }
                    return capacitacions;
    }

    public static boolean addProfessor(connect con, professor p) throws SQLException {
        if (p!=null) {
            String sql="insert ignore into t_capacitacions(t_professor_id,t_assignatura_id,t_assignatura_tipologia_id) select ?,t_assignatura_id,t_tipologia_id from t_assignatures_tipologia where t_assignatura_tipologia_ncredits>0";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, p.getId());
            int rs = pStmt.executeUpdate();
            return true;
        } else return false;
    }

    public static boolean deleteProfessor(connect con, professor p, assignatura a) {
        try {
            String sql="DELETE from t_capacitacions where t_assignatura_id=? and t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, a.getId());
            pStmt.setInt(2, p.getId());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_capacitacions.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }


}
