-- phpMyAdmin SQL Dump
-- version 3.2.4
-- http://www.phpmyadmin.net
--
-- Servidor: localhost
-- Tiempo de generación: 01-06-2011 a las 08:05:06
-- Versión del servidor: 5.1.41
-- Versión de PHP: 5.3.1

SET SQL_MODE="NO_AUTO_VALUE_ON_ZERO";


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;

--
-- Base de datos: `epghd`
--

-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `t_assignatures`
--

CREATE TABLE IF NOT EXISTS `t_assignatures` (
  `t_assignatura_id` int(11) NOT NULL AUTO_INCREMENT,
  `t_assignatura_nom` varchar(100) NOT NULL,
  `t_assignatura_ncredits` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_assignatura_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=52 ;


CREATE TABLE IF NOT EXISTS `t_assignatures_tipologia` (
  `t_assignatura_id` int(11) NOT NULL,
  `t_tipologia_id` int(11) NOT NULL,
  `t_assignatura_tipologia_ncredits` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_assignatura_id`,`t_tipologia_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

-- Estructura de tabla para la tabla `t_assignatures_tipologia_grup`
--

CREATE TABLE IF NOT EXISTS `t_assignatures_tipologia_grup` (
  `t_assignatura_id` int(11) NOT NULL,
  `t_tipologia_id` int(11) NOT NULL,
  `t_grup_id` int(11) NOT NULL AUTO_INCREMENT,
  `t_grup_nom` varchar(25) NOT NULL,
  `t_grup_quatrimestre` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_assignatura_id`,`t_tipologia_id`,`t_grup_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;


CREATE TABLE IF NOT EXISTS `t_capacitacions` (
  `t_professor_id` int(11) NOT NULL,
  `t_assignatura_id` int(11) NOT NULL,
  `t_assignatura_tipologia_id` int(11) NOT NULL,
  PRIMARY KEY (`t_professor_id`,`t_assignatura_id`,`t_assignatura_tipologia_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Volcar la base de datos para la tabla `t_capacitacions`
--

CREATE TABLE IF NOT EXISTS `t_franja_horaria` (
  `t_franja_horaria_id` int(11) NOT NULL AUTO_INCREMENT,
  `t_franja_horaria_dia` int(11) NOT NULL,
  `t_franja_horaria_inici` int(11) NOT NULL,
  `t_franja_horaria_final` int(11) NOT NULL,
  PRIMARY KEY (`t_franja_horaria_id`)
) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=131 ;

--
-- Volcar la base de datos para la tabla `t_franja_horaria`
--

--

CREATE TABLE IF NOT EXISTS `t_horaris_grups` (
  `t_grup_id` int(11) NOT NULL,
  `t_assignatura_id` int(11) NOT NULL,
  `t_tipologia_id` int(11) NOT NULL,
  `t_franja_horaria_id` int(11) NOT NULL,
  PRIMARY KEY (`t_grup_id`,`t_assignatura_id`,`t_tipologia_id`,`t_franja_horaria_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Volcar la base de datos para la tabla `t_horaris_grups`
--


-- --------------------------------------------------------

--
-- Estructura de tabla para la tabla `t_horaris_professors`
--

CREATE TABLE IF NOT EXISTS `t_horaris_professors` (
  `t_professor_id` int(11) NOT NULL,
  `t_franja_horaria_id` int(11) NOT NULL,
  `t_horaris_professors_quatrimestre` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`t_professor_id`,`t_franja_horaria_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

--
-- Volcar la base de datos para la tabla `t_horaris_professors`
--

