package fzn2smt;

// $ANTLR 3.2 Sep 23, 2009 12:02:23 L:\\CompFlatzinc\\CompFlatzincResult.g 2010-07-27 09:00:23

import java.io.*; 
import java.lang.Object; 
import java.util.Vector;   
import java.util.Set;   
import java.util.SortedSet;   
import java.util.TreeSet;   
import java.util.Iterator;  


import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;


import org.antlr.runtime.tree.*;

public class CompFlatzincResultParser extends Parser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "IDENT", "INT_LITERAL", "FLOAT_LITERAL", "WS", "COMMENT", "'sat'", "'MODEL'", "'unsat'", "'unknown'", "'('", "'='", "')'", "'/'", "'true'", "'false'"
    };
    public static final int FLOAT_LITERAL=6;
    public static final int INT_LITERAL=5;
    public static final int WS=7;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int T__10=10;
    public static final int IDENT=4;
    public static final int COMMENT=8;
    public static final int EOF=-1;
    public static final int T__9=9;

    // delegates
    // delegators


        public CompFlatzincResultParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public CompFlatzincResultParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        
    protected TreeAdaptor adaptor = new CommonTreeAdaptor();

    public void setTreeAdaptor(TreeAdaptor adaptor) {
        this.adaptor = adaptor;
    }
    public TreeAdaptor getTreeAdaptor() {
        return adaptor;
    }

    public String[] getTokenNames() { return CompFlatzincResultParser.tokenNames; }
    public String getGrammarFileName() { return "L:\\CompFlatzinc\\CompFlatzincResult.g"; }


    	SymTable<Regsort> stsort=new SymTable<Regsort>(10);
    	boolean expandir=false;
    	ListString slig=new ListString();
    	int contslig=0;
    	String esoguio=" ";
    	String po="(";
    	String pt=")";

        	public void displayRecognitionError(String[] tokenNames,RecognitionException e) {
            	String hdr = getErrorHeader(e);
            	String msg = getErrorMessage(e, tokenNames);
            	System.err.println("     ");
        	}

    	private String treure_V(String a)
    	{
    		if (a==null)
    		{
    			return("");
    		}
    		else
    		{
    			String aux="";
    			int c=0;
    			int i1=a.indexOf("V",c);
    			int i2=a.indexOf("N",c);		
    			int i;
    			if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
    			while (i!=(-1))
    			{
    				aux=aux+a.substring(c,i);
    				c=i+1;			
    				i1=a.indexOf("V",c);
    				i2=a.indexOf("N",c);
    				if (i1==(-1)) {i=i2;} else {if (i2==(-1)) {i=i1;} else {if (i1<i2) {i=i1;} else {i=i2;}}}
    			}
    			aux=aux+a.substring(c,a.length());
    			return(aux);
    		}
    	}
    	
    	private void traspas_a_registre_sortida(SymTable<Registre> st, SymTable<Regsort> stsort)
    	{
    		Iterator<String> s=st.conjuntClaus().iterator();
    		Registre r;
    		while (s.hasNext())
    		{
    			r=st.obtenir(s.next());
    			String lexema=r.getLexema();
    			String out=r.getOut();
    			Boolean ini=r.getInicialitzat();
    			if (!r.getIgual().equals(""))
    			{
    				r=st.obtenir(r.getIgual());
    			}
    			if (!out.equals(""))
    			{
    				Regsort rs=new Regsort();
    				rs.putLexema(lexema);
    				rs.putSignatura(treure_V(r.getSignatura()));
    				rs.putInicialitzat(ini);
    				rs.putOut(out);				
    				if (rs.getInicialitzat()) 
    				{
    					rs.putVariable("N");
    				} 
    				else 
    				{
    					rs.putVariable("V");
    				}
    				rs.putValor("");
    				if (rs.getSignatura().equals("B")) {rs.putValor(((Boolean)r.getValorBool()).toString());}
    				if (rs.getSignatura().equals("I")) {rs.putValor(((Integer)r.getValorInt()).toString());}
    				if (rs.getSignatura().equals("F")) {rs.putValor(((Float)r.getValorFloat()).toString());}
    				rs.putValorArray(r.getValorArray());
    				rs.putDim(r.getDim());
    				rs.putValorSet(r.getValorSet());
    				stsort.inserir(rs.getLexema(),rs);
    			}
    		}
    		
    	}
    	
    	private void imprimir_sortida(SymTable<Regsort> stsort,SymTable<Registre> st)
    	{
    		SortedSet<String> ordenats=new TreeSet<String>();
    		ordenats.addAll(stsort.conjuntClaus());
    		Iterator<String> s=ordenats.iterator();
    		Regsort rs;
    		while (s.hasNext())
    		{
    			rs=stsort.obtenir(s.next());
    			String outa=rs.getOut();
    			String signatura=rs.getSignatura();
    			if (signatura.equals("I") || signatura.equals("B") || signatura.equals("F")) 
    			{
    				if (rs.getInicialitzat())
    				{
    					if (signatura.equals("F"))
    					{
    						System.out.println(rs.getLexema()+" = "+rs.getValor()+";");
    					}
    					else
    					{
    						System.out.println(rs.getLexema()+" = "+rs.getValor()+";");
    					}
    				}
    				else
    				{
    					System.out.println(rs.getLexema()+" = "+"undefined;");
    				}
    			}
    			else
    			{
    				if (signatura.equals("SI"))
    				{
    					System.out.print(rs.getLexema()+" = {");
    					ListBool ls=rs.getValorSet();
    					Boolean primer=true;
    					SortedSet<Integer> ordenats2=new TreeSet<Integer>();
    					ordenats2.addAll(ls.conjuntClaus());
    					Iterator<Integer> j=ordenats2.iterator();
    					while (j.hasNext())
    					{
    						Integer r=j.next();
    						if (ls.existeix(r))
    						{
    							if (!primer) {System.out.print(", ");} else {primer=false;}
    							System.out.print(r.toString());
    						}
    					}
    					System.out.println("};");
    				}
    				else
    				{
    					System.out.print(rs.getLexema()+" = ");
    					if (!outa.equals("output")) {System.out.print("array"+outa+", ");}
    					System.out.print("[");
    					ListString ls=rs.getValorArray();
    					int dim=rs.getDim();
    					for (int j=1; j<=dim; j++)
    					{
    						if (j>1) {System.out.print(", ");}
    						if (ls.existeix(j))
    						{
    							if (signatura.equals("[SI"))
    							{
    								Registre rs2=st.obtenir(ls.obtenir(j));
    								System.out.print("{");
    								ListBool lb=rs2.getValorSet();
    								Boolean primer=true;
    								SortedSet<Integer> ordenats3=new TreeSet<Integer>();
    								ordenats3.addAll(lb.conjuntClaus());
    								Iterator<Integer> j2=ordenats3.iterator();
    								while (j2.hasNext())
    								{
    									Integer r=j2.next();
    									if (lb.existeix(r))
    									{
    										if (!primer) {System.out.print(", ");} else {primer=false;}
    										System.out.print(r.toString());
    									}
    								}
    								System.out.print("}");
    							}
    							else //vector de diferents de set
    							{
    								System.out.print(ls.obtenir(j));
    							}
    						}
    						else
    						{
    								System.out.print("undefined");
    						}
    					}
    					System.out.print("]");
    					if (!outa.equals("output")) {System.out.print(")");}
    					System.out.println(";");
    				} 
    			}
    		}
    	}


    	private void no_inicialitzats_igual(SymTable<Registre> st)	
    	{
    		Boolean nomod=true;
    		while (nomod && slig.tamany()!=0)
    		{
    			nomod=false;
    			Iterator<Integer> it=slig.conjuntClaus().iterator();
    			while (it.hasNext())
    			{
    				Integer iio=it.next();
    				String ss=slig.obtenir(iio);
    				String s2[]=ss.split("#");
    				Registre rig1=st.obtenir(s2[0]);
    				Registre rig2=st.obtenir(s2[1]);
    				if (!rig1.getInicialitzat() && rig2.getInicialitzat())
    				{
    					nomod=true;
    					rig1.putIgual(rig2.getLexema());
    					rig1.putInicialitzat(true);
    					st.modificar(rig1.getLexema(),rig1);
    				}
    				rig1=st.obtenir(s2[0]);	
    				if (rig1.getInicialitzat() && !rig2.getInicialitzat())
    				{
    					nomod=true;
    					rig2.putIgual(rig1.getLexema());
    					rig2.putInicialitzat(true);
    					st.modificar(rig2.getLexema(),rig2);	
    				}
    				//slig.esborrar(iio);	
    			}
    		}
    	}


    public static class model_return extends ParserRuleReturnScope {
        public String valor;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "model"
    // L:\\CompFlatzinc\\CompFlatzincResult.g:237:1: model[SymTable<Registre> st, boolean exp, Boolean max] returns [String valor] : ( 'sat' 'MODEL' (ig= igualtats[$st, $exp, $max] )* | 'unsat' ( . )* | 'unknown' ( . )* );
    public final CompFlatzincResultParser.model_return model(SymTable<Registre> st, boolean exp, Boolean max) throws RecognitionException {
        CompFlatzincResultParser.model_return retval = new CompFlatzincResultParser.model_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token string_literal1=null;
        Token string_literal2=null;
        Token string_literal3=null;
        Token wildcard4=null;
        Token string_literal5=null;
        Token wildcard6=null;
        CompFlatzincResultParser.igualtats_return ig = null;


        Object string_literal1_tree=null;
        Object string_literal2_tree=null;
        Object string_literal3_tree=null;
        Object wildcard4_tree=null;
        Object string_literal5_tree=null;
        Object wildcard6_tree=null;

        try {
            // L:\\CompFlatzinc\\CompFlatzincResult.g:238:2: ( 'sat' 'MODEL' (ig= igualtats[$st, $exp, $max] )* | 'unsat' ( . )* | 'unknown' ( . )* )
            int alt4=3;
            switch ( input.LA(1) ) {
            case 9:
                {
                alt4=1;
                }
                break;
            case 11:
                {
                alt4=2;
                }
                break;
            case 12:
                {
                alt4=3;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }

            switch (alt4) {
                case 1 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:238:4: 'sat' 'MODEL' (ig= igualtats[$st, $exp, $max] )*
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal1=(Token)match(input,9,FOLLOW_9_in_model44); 
                    string_literal1_tree = (Object)adaptor.create(string_literal1);
                    adaptor.addChild(root_0, string_literal1_tree);

                    	
                    			expandir=exp;
                    			retval.valor ="";
                    		
                    string_literal2=(Token)match(input,10,FOLLOW_10_in_model55); 
                    string_literal2_tree = (Object)adaptor.create(string_literal2);
                    adaptor.addChild(root_0, string_literal2_tree);

                    // L:\\CompFlatzinc\\CompFlatzincResult.g:244:3: (ig= igualtats[$st, $exp, $max] )*
                    loop1:
                    do {
                        int alt1=2;
                        int LA1_0 = input.LA(1);

                        if ( (LA1_0==13) ) {
                            alt1=1;
                        }


                        switch (alt1) {
                    	case 1 :
                    	    // L:\\CompFlatzinc\\CompFlatzincResult.g:244:4: ig= igualtats[$st, $exp, $max]
                    	    {
                    	    pushFollow(FOLLOW_igualtats_in_model63);
                    	    ig=igualtats(st, exp, max);

                    	    state._fsp--;

                    	    adaptor.addChild(root_0, ig.getTree());
                    	    if ((ig!=null?ig.maxi:null).equals("maximize_")) {retval.valor =(ig!=null?ig.maxv:null);}

                    	    }
                    	    break;

                    	default :
                    	    break loop1;
                        }
                    } while (true);


                    			if (!max)
                    			{
                    				no_inicialitzats_igual(st);
                    				slig=new ListString();
                    				traspas_a_registre_sortida(st, stsort);
                    				imprimir_sortida(stsort,st);
                    				System.out.println("----------");
                    			}
                    		

                    }
                    break;
                case 2 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:257:4: 'unsat' ( . )*
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal3=(Token)match(input,11,FOLLOW_11_in_model85); 
                    string_literal3_tree = (Object)adaptor.create(string_literal3);
                    adaptor.addChild(root_0, string_literal3_tree);

                    // L:\\CompFlatzinc\\CompFlatzincResult.g:257:13: ( . )*
                    loop2:
                    do {
                        int alt2=2;
                        int LA2_0 = input.LA(1);

                        if ( ((LA2_0>=IDENT && LA2_0<=18)) ) {
                            alt2=1;
                        }
                        else if ( (LA2_0==EOF) ) {
                            alt2=2;
                        }


                        switch (alt2) {
                    	case 1 :
                    	    // L:\\CompFlatzinc\\CompFlatzincResult.g:257:13: .
                    	    {
                    	    wildcard4=(Token)input.LT(1);
                    	    matchAny(input); 
                    	    wildcard4_tree = (Object)adaptor.create(wildcard4);
                    	    adaptor.addChild(root_0, wildcard4_tree);


                    	    }
                    	    break;

                    	default :
                    	    break loop2;
                        }
                    } while (true);

                    retval.valor ="unsat";if (!max) {System.out.println("=====UNSATISFIABLE=====");}

                    }
                    break;
                case 3 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:258:4: 'unknown' ( . )*
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal5=(Token)match(input,12,FOLLOW_12_in_model97); 
                    string_literal5_tree = (Object)adaptor.create(string_literal5);
                    adaptor.addChild(root_0, string_literal5_tree);

                    // L:\\CompFlatzinc\\CompFlatzincResult.g:258:14: ( . )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( ((LA3_0>=IDENT && LA3_0<=18)) ) {
                            alt3=1;
                        }
                        else if ( (LA3_0==EOF) ) {
                            alt3=2;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // L:\\CompFlatzinc\\CompFlatzincResult.g:258:14: .
                    	    {
                    	    wildcard6=(Token)input.LT(1);
                    	    matchAny(input); 
                    	    wildcard6_tree = (Object)adaptor.create(wildcard6);
                    	    adaptor.addChild(root_0, wildcard6_tree);


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);

                    retval.valor ="unKnown";if (!max) {System.out.println("=====UNKNOWN=====");}

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "model"

    public static class igualtats_return extends ParserRuleReturnScope {
        public String maxi;
        public String maxv;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "igualtats"
    // L:\\CompFlatzinc\\CompFlatzincResult.g:261:1: igualtats[SymTable<Registre> st, boolean exp, Boolean max] returns [String maxi,String maxv] : '(' '=' i= identifier v= valor ')' ;
    public final CompFlatzincResultParser.igualtats_return igualtats(SymTable<Registre> st, boolean exp, Boolean max) throws RecognitionException {
        CompFlatzincResultParser.igualtats_return retval = new CompFlatzincResultParser.igualtats_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token char_literal7=null;
        Token char_literal8=null;
        Token char_literal9=null;
        CompFlatzincResultParser.identifier_return i = null;

        CompFlatzincResultParser.valor_return v = null;


        Object char_literal7_tree=null;
        Object char_literal8_tree=null;
        Object char_literal9_tree=null;

        try {
            // L:\\CompFlatzinc\\CompFlatzincResult.g:262:2: ( '(' '=' i= identifier v= valor ')' )
            // L:\\CompFlatzinc\\CompFlatzincResult.g:262:4: '(' '=' i= identifier v= valor ')'
            {
            root_0 = (Object)adaptor.nil();

            char_literal7=(Token)match(input,13,FOLLOW_13_in_igualtats121); 
            char_literal7_tree = (Object)adaptor.create(char_literal7);
            adaptor.addChild(root_0, char_literal7_tree);

            char_literal8=(Token)match(input,14,FOLLOW_14_in_igualtats123); 
            char_literal8_tree = (Object)adaptor.create(char_literal8);
            adaptor.addChild(root_0, char_literal8_tree);

            pushFollow(FOLLOW_identifier_in_igualtats127);
            i=identifier();

            state._fsp--;

            adaptor.addChild(root_0, i.getTree());
            pushFollow(FOLLOW_valor_in_igualtats131);
            v=valor();

            state._fsp--;

            adaptor.addChild(root_0, v.getTree());
            char_literal9=(Token)match(input,15,FOLLOW_15_in_igualtats132); 
            char_literal9_tree = (Object)adaptor.create(char_literal9);
            adaptor.addChild(root_0, char_literal9_tree);


            			retval.maxi =(i!=null?i.id:null);
            			retval.maxv =(v!=null?v.val:null);
            			if (!max)
            			{
            				String id=(i!=null?i.id:null);
            				String pos=(i!=null?i.pos:null);
            				String vset="";
            				String auxaux1="";
            				String auxaux2="";
            				String auxaux3="";
            				String auxaux4="";
            				auxaux4=id;
            				if (id.matches("[a-zA-Z0-9_-]+_-?[0-9]+_") && pos.equals(""))
            				{
            					int ii=id.length();
            					ii--;
            					char a=id.charAt(ii-1);
            					while (a!='_')
            					{
            						ii--;
            						a=id.charAt(ii);
            					}
            					id=(i!=null?i.id:null).substring(0,ii);
            					pos=(i!=null?i.id:null).substring(ii+1,(i!=null?i.id:null).length()-1);
            					auxaux3=id;
            					/*if (id.matches("[a-zA-Z0-9_]+__i-i"))
            					{
            						id=id.substring(0,id.length()-3);
            					}*/
            					auxaux2=id;
            					if (id.matches("[a-zA-Z0-9_]+_i-i"))
            					{
            						id=id.substring(0,id.length()-4);
            					}
            					auxaux1=id;
            					if (id.matches("[a-zA-Z0-9_]+_-?[0-9]+_"))
            					{
            						int ii2=id.length();
            						ii2--;
            						char a2=id.charAt(ii2-1);
            						while (a2!='_')
            						{
            							ii2--;
            							a2=id.charAt(ii2);
            						}
            						vset=pos;
            						pos=id.substring(ii2+1,id.length()-1);
            						id=id.substring(0,ii2);
            					}
            				}
            				Registre r;
            				if (!st.existeix(id))
            				{
            					id=auxaux1;
            					pos=vset;
            					vset="";
            					if (!st.existeix(auxaux1))
            					{
            						id=auxaux2;
            						if (!st.existeix(auxaux2))
            						{
            							id=auxaux3;
            							if (!st.existeix(auxaux3))
            							{
            								id=(i!=null?i.id:null);
            								pos=(i!=null?i.pos:null);	
            								r=st.obtenir(auxaux4);					}
            							else
            							{
            								r=st.obtenir(auxaux3);
            							}
            						}
            						else
            						{
            							r=st.obtenir(auxaux2);
            						}
            					}
            					else
            					{
            						r=st.obtenir(auxaux1);
            					}
            	
            			}
            				else
            				{
            					r=st.obtenir(id);
            				}
            				id=r.getLexema();
            				String signatura=treure_V(r.getSignatura());
            				if (signatura.equals("SI") && vset.equals("")) {vset=pos;pos="";}			
            				if (!(v!=null?v.tipus:null).equals("S"))
            				{
            					if (signatura.equals("I") || signatura.equals("B") || signatura.equals("F")) 
            					{
            						if (signatura.equals("B")) {r.putValorBool(Boolean.parseBoolean((v!=null?v.val:null)));}
            						if (signatura.equals("I")) {r.putValorInt(Integer.parseInt((v!=null?v.val:null)));}
            						if (signatura.equals("F")) 
            						{
            							Double f3;
            							if ((v!=null?v.val:null).matches(".*/.*"))
            							{
            								
            								String[] ff=new String[2];
            								ff[0]="";
            								ff[1]="";
            								ff=(v!=null?v.val:null).split("/");
            								/*Long i11=Long.parseLong(ff[0]);
            								Long i12=Long.parseLong(ff[1]);
            								Float f1=i11.floatValue();
            								Float f2=i12.floatValue();*/
            								Double f1=new Double(ff[0]);
            								Double f2=new Double(ff[1]);
            								f3=f1/f2;
            							}	
            							else
            							{
            								//Long i11=Long.parseLong((v!=null?v.val:null));
            								f3=new Double((v!=null?v.val:null));
            								//f3=i11.floatValue();
            							}
            							r.putValorFloat(f3.floatValue());
            						}				
            					}
            					else
            					{
            						if (signatura.equals("SI"))
            						{
            							ListBool lb=r.getValorSet();
            							if (!lb.existeix(Integer.parseInt(vset)) && (v!=null?v.tipus:null).equals("B"))
            							{
            								if (Boolean.parseBoolean((v!=null?v.val:null)))
            								{
            									lb.inserir(Integer.parseInt(vset),true);
            									r.putValorSet(lb);
            								}
            							}
            						}
            						else
            						{
            							if (signatura.equals("[SI"))
            							{
            								ListString ls=r.getValorArray();
            								String s=ls.obtenir(Integer.parseInt(pos));
            								Registre r2=st.obtenir(s);
            								ListBool lb=r2.getValorSet();
            								if (!lb.existeix(Integer.parseInt(vset)) && (v!=null?v.tipus:null).equals("B"))
            								{
            									if (Boolean.parseBoolean((v!=null?v.val:null)))
            									{
            										lb.inserir(Integer.parseInt(vset),true);
            									}
            								}
            								/*else
            								{
            									if (Boolean.parseBoolean((v!=null?v.val:null)))
            									{
            										lb.modificar(Integer.parseInt(vset),true);
            									}
            								}*/
            								r2.putValorSet(lb);
            								r2.putInicialitzat(true);
            								st.modificar(r2.getLexema(),r2);
            							}
            							else //vector de diferents de set
            							{
            								ListString ls=r.getValorArray();
            								if (!ls.existeix(Integer.parseInt(pos)))
            								{
            									ls.inserir(Integer.parseInt(pos),(v!=null?v.val:null));
            								}
            								else
            								{
            									ls.modificar(Integer.parseInt(pos),(v!=null?v.val:null));
            								}
            								r.putValorArray(ls);
            							}
            						}
            					}
            					r.putInicialitzat(true);
            					st.modificar(r.getLexema(),r);
            				}
            				else
            				{
            					Registre r1=st.obtenir((i!=null?input.toString(i.start,i.stop):null));
            					Registre r2=st.obtenir((v!=null?input.toString(v.start,v.stop):null));
            					if (!r1.getInicialitzat() || !r2.getInicialitzat()) 
            					{
            						contslig++;
            						slig.inserir(contslig,r1.getLexema()+"#"+r2.getLexema());
            					}
            				}
            			}
            		

            }

            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "igualtats"

    public static class identifier_return extends ParserRuleReturnScope {
        public String id;
        public String pos;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "identifier"
    // L:\\CompFlatzinc\\CompFlatzincResult.g:459:1: identifier returns [String id, String pos] : (i= IDENT | '(' i= IDENT i2= INT_LITERAL ')' );
    public final CompFlatzincResultParser.identifier_return identifier() throws RecognitionException {
        CompFlatzincResultParser.identifier_return retval = new CompFlatzincResultParser.identifier_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token i=null;
        Token i2=null;
        Token char_literal10=null;
        Token char_literal11=null;

        Object i_tree=null;
        Object i2_tree=null;
        Object char_literal10_tree=null;
        Object char_literal11_tree=null;

        try {
            // L:\\CompFlatzinc\\CompFlatzincResult.g:460:2: (i= IDENT | '(' i= IDENT i2= INT_LITERAL ')' )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==IDENT) ) {
                alt5=1;
            }
            else if ( (LA5_0==13) ) {
                alt5=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:460:4: i= IDENT
                    {
                    root_0 = (Object)adaptor.nil();

                    i=(Token)match(input,IDENT,FOLLOW_IDENT_in_identifier155); 
                    i_tree = (Object)adaptor.create(i);
                    adaptor.addChild(root_0, i_tree);

                    retval.id =(i!=null?i.getText():null);retval.pos ="";

                    }
                    break;
                case 2 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:461:4: '(' i= IDENT i2= INT_LITERAL ')'
                    {
                    root_0 = (Object)adaptor.nil();

                    char_literal10=(Token)match(input,13,FOLLOW_13_in_identifier162); 
                    char_literal10_tree = (Object)adaptor.create(char_literal10);
                    adaptor.addChild(root_0, char_literal10_tree);

                    i=(Token)match(input,IDENT,FOLLOW_IDENT_in_identifier166); 
                    i_tree = (Object)adaptor.create(i);
                    adaptor.addChild(root_0, i_tree);

                    i2=(Token)match(input,INT_LITERAL,FOLLOW_INT_LITERAL_in_identifier170); 
                    i2_tree = (Object)adaptor.create(i2);
                    adaptor.addChild(root_0, i2_tree);

                    char_literal11=(Token)match(input,15,FOLLOW_15_in_identifier171); 
                    char_literal11_tree = (Object)adaptor.create(char_literal11);
                    adaptor.addChild(root_0, char_literal11_tree);

                    retval.id =(i!=null?i.getText():null);retval.pos =(i2!=null?i2.getText():null);

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "identifier"

    public static class valor_return extends ParserRuleReturnScope {
        public String tipus;
        public String val;
        Object tree;
        public Object getTree() { return tree; }
    };

    // $ANTLR start "valor"
    // L:\\CompFlatzinc\\CompFlatzincResult.g:464:1: valor returns [String tipus, String val] : (i= INT_LITERAL | t= INT_LITERAL '/' t2= INT_LITERAL | 'true' | 'false' | z= IDENT );
    public final CompFlatzincResultParser.valor_return valor() throws RecognitionException {
        CompFlatzincResultParser.valor_return retval = new CompFlatzincResultParser.valor_return();
        retval.start = input.LT(1);

        Object root_0 = null;

        Token i=null;
        Token t=null;
        Token t2=null;
        Token z=null;
        Token char_literal12=null;
        Token string_literal13=null;
        Token string_literal14=null;

        Object i_tree=null;
        Object t_tree=null;
        Object t2_tree=null;
        Object z_tree=null;
        Object char_literal12_tree=null;
        Object string_literal13_tree=null;
        Object string_literal14_tree=null;

        try {
            // L:\\CompFlatzinc\\CompFlatzincResult.g:465:2: (i= INT_LITERAL | t= INT_LITERAL '/' t2= INT_LITERAL | 'true' | 'false' | z= IDENT )
            int alt6=5;
            switch ( input.LA(1) ) {
            case INT_LITERAL:
                {
                int LA6_1 = input.LA(2);

                if ( (LA6_1==16) ) {
                    alt6=2;
                }
                else if ( (LA6_1==15) ) {
                    alt6=1;
                }
                else {
                    NoViableAltException nvae =
                        new NoViableAltException("", 6, 1, input);

                    throw nvae;
                }
                }
                break;
            case 17:
                {
                alt6=3;
                }
                break;
            case 18:
                {
                alt6=4;
                }
                break;
            case IDENT:
                {
                alt6=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }

            switch (alt6) {
                case 1 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:465:4: i= INT_LITERAL
                    {
                    root_0 = (Object)adaptor.nil();

                    i=(Token)match(input,INT_LITERAL,FOLLOW_INT_LITERAL_in_valor190); 
                    i_tree = (Object)adaptor.create(i);
                    adaptor.addChild(root_0, i_tree);

                    retval.tipus ="I";retval.val =(i!=null?i.getText():null);

                    }
                    break;
                case 2 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:466:4: t= INT_LITERAL '/' t2= INT_LITERAL
                    {
                    root_0 = (Object)adaptor.nil();

                    t=(Token)match(input,INT_LITERAL,FOLLOW_INT_LITERAL_in_valor199); 
                    t_tree = (Object)adaptor.create(t);
                    adaptor.addChild(root_0, t_tree);

                    char_literal12=(Token)match(input,16,FOLLOW_16_in_valor201); 
                    char_literal12_tree = (Object)adaptor.create(char_literal12);
                    adaptor.addChild(root_0, char_literal12_tree);

                    t2=(Token)match(input,INT_LITERAL,FOLLOW_INT_LITERAL_in_valor205); 
                    t2_tree = (Object)adaptor.create(t2);
                    adaptor.addChild(root_0, t2_tree);

                    retval.tipus ="F";retval.val =(t!=null?t.getText():null)+"/"+(t2!=null?t2.getText():null);

                    }
                    break;
                case 3 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:467:4: 'true'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal13=(Token)match(input,17,FOLLOW_17_in_valor212); 
                    string_literal13_tree = (Object)adaptor.create(string_literal13);
                    adaptor.addChild(root_0, string_literal13_tree);

                    retval.tipus ="B";retval.val ="true";

                    }
                    break;
                case 4 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:468:4: 'false'
                    {
                    root_0 = (Object)adaptor.nil();

                    string_literal14=(Token)match(input,18,FOLLOW_18_in_valor219); 
                    string_literal14_tree = (Object)adaptor.create(string_literal14);
                    adaptor.addChild(root_0, string_literal14_tree);

                    retval.tipus ="B";retval.val ="false";

                    }
                    break;
                case 5 :
                    // L:\\CompFlatzinc\\CompFlatzincResult.g:469:4: z= IDENT
                    {
                    root_0 = (Object)adaptor.nil();

                    z=(Token)match(input,IDENT,FOLLOW_IDENT_in_valor228); 
                    z_tree = (Object)adaptor.create(z);
                    adaptor.addChild(root_0, z_tree);

                    retval.tipus ="S";retval.val =(z!=null?z.getText():null);

                    }
                    break;

            }
            retval.stop = input.LT(-1);

            retval.tree = (Object)adaptor.rulePostProcessing(root_0);
            adaptor.setTokenBoundaries(retval.tree, retval.start, retval.stop);

        }
        catch (RecognitionException re) {
            reportError(re);
            recover(input,re);
    	retval.tree = (Object)adaptor.errorNode(input, retval.start, input.LT(-1), re);

        }
        finally {
        }
        return retval;
    }
    // $ANTLR end "valor"

    // Delegated rules


 

    public static final BitSet FOLLOW_9_in_model44 = new BitSet(new long[]{0x0000000000000400L});
    public static final BitSet FOLLOW_10_in_model55 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_igualtats_in_model63 = new BitSet(new long[]{0x0000000000002002L});
    public static final BitSet FOLLOW_11_in_model85 = new BitSet(new long[]{0x000000000007FFF2L});
    public static final BitSet FOLLOW_12_in_model97 = new BitSet(new long[]{0x000000000007FFF2L});
    public static final BitSet FOLLOW_13_in_igualtats121 = new BitSet(new long[]{0x0000000000004000L});
    public static final BitSet FOLLOW_14_in_igualtats123 = new BitSet(new long[]{0x0000000000002010L});
    public static final BitSet FOLLOW_identifier_in_igualtats127 = new BitSet(new long[]{0x0000000000060030L});
    public static final BitSet FOLLOW_valor_in_igualtats131 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_15_in_igualtats132 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_identifier155 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_13_in_identifier162 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_IDENT_in_identifier166 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_INT_LITERAL_in_identifier170 = new BitSet(new long[]{0x0000000000008000L});
    public static final BitSet FOLLOW_15_in_identifier171 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_LITERAL_in_valor190 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_INT_LITERAL_in_valor199 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_valor201 = new BitSet(new long[]{0x0000000000000020L});
    public static final BitSet FOLLOW_INT_LITERAL_in_valor205 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_valor212 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_valor219 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_IDENT_in_valor228 = new BitSet(new long[]{0x0000000000000002L});

}