 package fzn2smt;

import java.io.*;
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;



public class fzn2smt 
{
	static PrintStream sortida;
	String inp;
	String comandaexec;

	public fzn2smt() {

	}

	public void setInput(String input) {
		this.inp=input;
	}
	public void setYices(String yices) {
		this.comandaexec=yices;
	}
	private static String neg(Integer pos2)
	{
		String pos=pos2.toString();
		if (pos.length()>=1)
		{
			if (pos.substring(0,1).equals("-"))
			{
				pos="(~ "+pos.substring(1,pos.length())+")";
			}
		}
		return(pos);
	}

	private static String buscar_valor(InputStream is, StringBuffer texte)
	{
		String r="";
            try
		{
			BufferedReader br = new BufferedReader (new InputStreamReader (is)); 
	            String aux = br.readLine();
			texte.append(aux+"\n\r");
			if (aux.equals("unsat") || aux.equals("unknown"))
			{
				r=aux;
			}
			else
			{
      			while (aux!=null) 
	        		{ 
					if (aux.length()>12)
					{        				
						if (aux.substring(0,13).equals("(= maximize_ "))
						{
							aux=aux.substring(13);
							int n=aux.indexOf(")");
							r=aux.substring(0,n);
						}		
					}
       	       		aux = br.readLine();
					texte.append(aux+"\n\r");
             			}
			}
		}
		catch (Exception e)
		{
			texte=null;
			return(r);
		}
		return(r);
	}


	public void execute() throws Exception 
	{
		CharStream input = null;
		//String inp="./pfc.fzn";
		String output = "resultat.txt";
                ByteArrayOutputStream baos=new ByteArrayOutputStream();
		Boolean expandir=true;
		Boolean executar=true;
		Boolean recover=true;
		String outputsmt="";
		
		//String comandaexec="./yices.exe -f";
		int i=0;
		String aux;
		boolean minzero2=false;
		PrintStream outptot2;
		String opttipus="b";
		String optorder="d";
		Integer optrange=5;

		//obrim l'input
		try
		{
			if (inp.equals("")) {input = new ANTLRInputStream(System.in);} else {input= new ANTLRFileStream(inp);}
		}
		catch (Exception e)
		{
			System.err.println("Bad file name : "+inp);
			return;
		}

		PrintStream auxoutput=System.out;

		//part LEXICA


        	CompFlatzincLexer lex = new CompFlatzincLexer(input);
        	CommonTokenStream tokens = new CommonTokenStream(lex);
        	CompFlatzincParser g = new CompFlatzincParser(tokens);
        	CompFlatzincParser.flatzinc_model_return result = g.flatzinc_model();
		CommonTree t = (CommonTree)result.getTree();
		if (result.cer>0) 
		{
			System.err.println(result.cer+" errors");
		}
		else 
		{

			try{
			//PART SINTACTICA I SEMANTICA

	    		CommonTreeNodeStream nodes = new CommonTreeNodeStream(t);
	    		nodes.setTokenStream(tokens);
	    		CompFlatzincWalker walker = new CompFlatzincWalker(nodes, null);
			String outp=outputsmt;
			if (outp.equals("") && (!executar || minzero2)) {outp=output;}
			if (outp.equals("") && !inp.equals("")) {outp=inp+".smt";}
			if (outp.equals("")) {outp="tmp.tmp.smt";}
	    		CompFlatzincWalker.flatzinc_model_return resultw=walker.flatzinc_model(expandir,outp,inp,executar,minzero2);
	    		//CommonTree tttt = (CommonTree)resultw.getTree();
	    		//System.err.println(tttt.toStringTree());
			if (!resultw.error2 && executar && (!minzero2))
			{
			
				//EXECUCIO


				Process p;
				p=Runtime.getRuntime().exec (comandaexec+" "+outp); 
             			InputStream is = p.getInputStream(); 
				
 

 
				if (!resultw.solveKindMax2)
				{
					PrintStream outptot;
						if (output.equals("")) {outptot=auxoutput;} else {outptot=new PrintStream(output);}
						System.setOut(outptot);
                                        if (recover)
					{
						ANTLRInputStream input22 = new ANTLRInputStream(is);
		       				CompFlatzincResultLexer lex2 = new CompFlatzincResultLexer(input22);
        					CommonTokenStream tokens2 = new CommonTokenStream(lex2);
        					CompFlatzincResultParser g2 = new CompFlatzincResultParser(tokens2);
 						CompFlatzincResultParser.model_return mr=g2.model(resultw.st2,expandir,resultw.solveKindMax2);

					}
					else
					{
              				BufferedReader br6 = new BufferedReader (new InputStreamReader (is)); 
           				String aux6 = br6.readLine(); 
	      	      			while (aux6!=null) 
        	  				{ 
							System.out.println(aux6);
	               	 				aux6 = br6.readLine(); 
            					}
					}
                                                        outptot.close();
                                        
				}
				
				else
				{
				        Boolean impiguals=false;
				        StringBuffer texte=new StringBuffer();
					String valor=buscar_valor(is,texte);
					String buffertext=texte.toString();
					if (valor.equals("unsat") || valor.equals("unknown") || valor.equals(""))
					{
 						PrintStream outptot;
						if (output.equals("")) {outptot=auxoutput;} else {outptot=new PrintStream(output);}
						System.out.close();
						System.setOut(new PrintStream(outptot));
						if (valor.equals("unsat")) 
						{
							System.out.println("=====UNSATISFIABLE=====");
						}
						else
						{
							if (valor.equals("unknown"))
							{
								System.out.println("=====UNKNOWN=====");
							}
							else
							{
								System.out.println("=====UNKNOWN=====");
							}
						}
						return;
					}
					else
					{
						if (output.equals("")) {outptot2=auxoutput;} else {outptot2=new PrintStream(output);}
						imprimir(buffertext,recover,expandir,resultw.st2,outptot2);
						impiguals=true;
						Integer in=Integer.parseInt(valor);
						Integer fi=Integer.parseInt(resultw.solveMax2);
						Integer mig=in;
						Integer rrr=2;

						while (in<fi)
						{
							OutputStream novaentrada=new FileOutputStream(outp+rrr+".tmp.smt");

						   	if (((fi-in)<=optrange) && opttipus.equals("h")) {opttipus="l";}
							
							if (opttipus.equals("l"))
							{
								mig=in+1;
							}
							else
							{
								mig=((in+fi+1) / 2);	
								if (mig==in) {mig=mig+1;}
							}
 							//System.err.println("in: "+in+" fi: "+fi+" mig: "+mig+" val: "+valor);
							InputStream is2=new FileInputStream(outp);
							BufferedReader br = new BufferedReader (new InputStreamReader (is2)); 
           						String aux22 = br.readLine(); 
							int iafegir=0;
							while (aux22!=null) 
        	  					{ 
                						if (iafegir==6)
								{
									//System.err.println("search : "+mig+" -- "+fi+" valor : "+in);
									novaentrada.write(("\t\t(>= maximize_ "+neg(mig)+")\n\r").getBytes()); 
									novaentrada.write(("\t\t(<= maximize_ "+neg(fi)+")\n\r").getBytes()); 
								}
								novaentrada.write((aux22+"\n\r").getBytes()); 
	                	 				aux22 = br.readLine(); 
								iafegir++;
							}
							is2.close();
							novaentrada.close();
							
							Process p2=Runtime.getRuntime().exec (comandaexec+" "+outp+rrr+".tmp.smt"); 
							//rrr++;
							//p2.waitFor();
							InputStream is22 = p2.getInputStream(); 
							texte=new StringBuffer();
 							valor=buscar_valor(is22,texte);
							//System.err.println("valor "+valor);
							is22.close();
  							if (valor.equals("unsat") || valor.equals("unknown") || valor.equals(""))
							{
								if (valor.equals(""))
								{
									return;
								}
								else
								{
									if (opttipus.equals("l"))
									{
										fi=in-1;
									}
									else
									{
										fi=mig-1;
									}
									is22.close();
									is.close();
								}
							}
							else
							{
								in=Integer.parseInt(valor);
								buffertext=texte.toString();
								imprimir(buffertext,recover,expandir,resultw.st2,outptot2);
							}
                                                       
						}
 						System.setOut(outptot2);
						System.out.println("==========");

							
					}
				}
			}
		        }
		        catch (RecognitionException e)
				{
				    System.err.println("=====UNKNOWN=====");
				    return;
			        }
		} 
	       
	}


	private static void imprimir(String buffertext,Boolean recover,Boolean expandir,SymTable<Registre> st2,PrintStream outptot2)
	{
 		try 
		{
			System.setOut(outptot2);

			if (recover)
			{
				ANTLRStringStream input22 = new ANTLRStringStream(buffertext);
				CompFlatzincResultLexer lex2 = new CompFlatzincResultLexer(input22);
	        		CommonTokenStream tokens2 = new CommonTokenStream(lex2);
        			CompFlatzincResultParser g2 = new CompFlatzincResultParser(tokens2);
 				CompFlatzincResultParser.model_return mr=g2.model(st2,expandir,false);
			}
			else
			{
				System.out.println(buffertext);
			}
		}
		catch (Exception e)
		{
			System.err.println("  ");
		}

	}				
}
