/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MantenirPresolucions.java
 *
 * Created on 15/05/2011, 23:50:06
 */

package gui;

import control.ctrl_franja_horaries;
import control.ctrl_presolucions;
import java.awt.Color;
import java.awt.Component;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import javax.swing.DefaultListModel;
import javax.swing.table.DefaultTableModel;
import objectes.professor;
import objectes.franjaHoraria;
import objectes.assignaturaTipologiaGrup;
import java.util.TreeSet;
import javax.swing.DefaultListCellRenderer;
import javax.swing.JLabel;
import javax.swing.ListCellRenderer;

/**
 *
 * @author z0rskrab
 */
public final class MantenirPresolucions extends javax.swing.JDialog {
    private professor pf;
    int quatrimestre;
    private DefaultListModel lstPossibleModel;
    /** Creates new form MantenirPresolucions */
    public MantenirPresolucions(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    public MantenirPresolucions(java.awt.Frame parent, boolean modal, Object p, int quatrimestre) {
        super(parent,modal);
        initComponents();
        this.pf=(professor) p;
        this.quatrimestre=quatrimestre;
        lblnomProfe.setText(pf.getNom()+" "+pf.getCognoms());
        ctrl_franja_horaries cfh=new ctrl_franja_horaries();
        lstPossibleModel=new DefaultListModel();
        carregarPresolucions(this.pf);
        carregarPresolucionsPossibles(this.pf, this.quatrimestre);
    }

    public void carregarPresolucions(professor p) {
        ctrl_presolucions cpr=new ctrl_presolucions();
        Object[] ctpr=cpr.selectAll(p);
        DefaultListModel dlm=new DefaultListModel();
        int size=ctpr.length;
        int i;
        for (i=0;i<size;i++) {
            dlm.addElement(ctpr[i]);
        }
        ListCellRenderer cs=new CustomRender();
        lstAssignades.setCellRenderer(cs);
        lstAssignades.setModel(dlm);

    }

    public void carregarPresolucionsPossibles(professor p, int quatrimestre) {
            ctrl_franja_horaries cfh=new ctrl_franja_horaries();
            HashMap llistaPreSolucions = cfh.selectPresolucions(p);
            DefaultListModel tblpossibles=new DefaultListModel();
            Object[] columnNames=new Object[6];
		columnNames[0]="";
		columnNames[1]="Dilluns";
		columnNames[2]="Dimarts";
		columnNames[3]="Dimecres";
		columnNames[4]="Dijous";
		columnNames[5]="Divendres";
            ctrl_franja_horaries horaris=new ctrl_franja_horaries();
            Object[][] dades=horaris.selectPersonalitzat(p,quatrimestre);
            DefaultTableModel horariProfessor=new DefaultTableModel(dades,columnNames);
                    for(int row = 0;row < horariProfessor.getRowCount();row++) {
                            for(int col = 0;col < horariProfessor.getColumnCount();col++) {
                                    Object casella=horariProfessor.getValueAt(row, col);
                                    if (casella instanceof franjaHoraria) {
                                        if (((franjaHoraria)casella).getMarcat()) {
                                            Iterator it=llistaPreSolucions.entrySet().iterator();
                                            while(it.hasNext()) {
                                                Map.Entry pairs = (Map.Entry)it.next();
                                                TreeSet aux=(TreeSet) pairs.getValue();
                                                aux.remove(((franjaHoraria)casella).getId());
                                             }
                                        }
                                    }
                            }
                    }

                            TreeSet<assignaturaTipologiaGrup> ordenat=new TreeSet();
                            Iterator its=llistaPreSolucions.entrySet().iterator();
                                        while(its.hasNext()) {
                                            Map.Entry pairs = (Map.Entry)its.next();
                                            TreeSet aux=(TreeSet) pairs.getValue();
                                            assignaturaTipologiaGrup auxKey=(assignaturaTipologiaGrup) pairs.getKey();
                                            if (aux.isEmpty()) {
                                                ordenat.add(auxKey);
                                            }
                                        }
                            Iterator foo=ordenat.iterator();
                            while (foo.hasNext()) {
                                    tblpossibles.addElement(foo.next());
                            }
                                    ListCellRenderer cs=new CustomRender();
        lstPossibles.setCellRenderer(cs);
                             lstPossibles.setModel(tblpossibles);

        }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstAssignades = new javax.swing.JList();
        jScrollPane2 = new javax.swing.JScrollPane();
        lstPossibles = new javax.swing.JList();
        btnDelPresolucio = new javax.swing.JButton();
        btnAddPresolucio = new javax.swing.JButton();
        jButton3 = new javax.swing.JButton();
        lblnomProfe = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(gui.ProvaApp.class).getContext().getResourceMap(MantenirPresolucions.class);
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        lstAssignades.setName("lstAssignades"); // NOI18N
        jScrollPane1.setViewportView(lstAssignades);

        jScrollPane2.setName("jScrollPane2"); // NOI18N

        lstPossibles.setName("lstPossibles"); // NOI18N
        jScrollPane2.setViewportView(lstPossibles);

        btnDelPresolucio.setText(resourceMap.getString("btnDelPresolucio.text")); // NOI18N
        btnDelPresolucio.setName("btnDelPresolucio"); // NOI18N
        btnDelPresolucio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDelPresolucioActionPerformed(evt);
            }
        });

        btnAddPresolucio.setText(resourceMap.getString("btnAddPresolucio.text")); // NOI18N
        btnAddPresolucio.setName("btnAddPresolucio"); // NOI18N
        btnAddPresolucio.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddPresolucioActionPerformed(evt);
            }
        });

        jButton3.setText(resourceMap.getString("jButton3.text")); // NOI18N
        jButton3.setName("jButton3"); // NOI18N
        jButton3.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton3ActionPerformed(evt);
            }
        });

        lblnomProfe.setText(resourceMap.getString("lblnomProfe.text")); // NOI18N
        lblnomProfe.setName("lblnomProfe"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        jLabel3.setText(resourceMap.getString("jLabel3.text")); // NOI18N
        jLabel3.setName("jLabel3"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(lblnomProfe)
                .addContainerGap())
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(253, Short.MAX_VALUE)
                .addComponent(jButton3)
                .addGap(235, 235, 235))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 225, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(btnAddPresolucio, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btnDelPresolucio, javax.swing.GroupLayout.PREFERRED_SIZE, 58, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(18, 18, 18))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addGap(173, 173, 173)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addComponent(jLabel3))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(lblnomProfe))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane2, 0, 0, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(28, 28, 28)
                        .addComponent(btnDelPresolucio)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnAddPresolucio))
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 112, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jButton3)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnDelPresolucioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDelPresolucioActionPerformed
        if (lstAssignades.getSelectedValue()!=null) {
            ctrl_presolucions cpr=new ctrl_presolucions();
            cpr.delete((assignaturaTipologiaGrup)lstAssignades.getSelectedValue(), this.pf);
            carregarPresolucionsPossibles(this.pf,quatrimestre);
            carregarPresolucions(this.pf);
        }
    }//GEN-LAST:event_btnDelPresolucioActionPerformed

    private void btnAddPresolucioActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddPresolucioActionPerformed
        if (lstPossibles.getSelectedValue()!=null) {
            ctrl_presolucions cpr=new ctrl_presolucions();
            cpr.insert((assignaturaTipologiaGrup)lstPossibles.getSelectedValue(), this.pf);
            carregarPresolucionsPossibles(this.pf, quatrimestre);
            carregarPresolucions(this.pf);
        }
    }//GEN-LAST:event_btnAddPresolucioActionPerformed

    private void jButton3ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton3ActionPerformed
        this.dispose();        // TODO add your handling code here:
    }//GEN-LAST:event_jButton3ActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                MantenirPresolucions dialog = new MantenirPresolucions(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    class CustomRender implements ListCellRenderer {
  protected DefaultListCellRenderer defaultRenderer = new DefaultListCellRenderer();
        private Color theForeground;

  public Component getListCellRendererComponent(javax.swing.JList list, Object value, int index,
      boolean isSelected, boolean cellHasFocus) {
    String theText = null;

    JLabel renderer = (JLabel) defaultRenderer.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);

    if (value instanceof assignaturaTipologiaGrup) {
        assignaturaTipologiaGrup dades=(assignaturaTipologiaGrup) value;
      theText=dades.getNom()+"=>"+dades.getNomTipologia()+"->"+dades.getNomGrup();
    } else {
      theForeground = list.getForeground();
      theText = "";
    }
    if (!isSelected) {
      renderer.setForeground(theForeground);
    }
    renderer.setText(theText);

    return renderer;
  }
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAddPresolucio;
    private javax.swing.JButton btnDelPresolucio;
    private javax.swing.JButton jButton3;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JLabel lblnomProfe;
    private javax.swing.JList lstAssignades;
    private javax.swing.JList lstPossibles;
    // End of variables declaration//GEN-END:variables

}
