/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * NewJDialog.java
 *
 * Created on 25/07/2011, 20:20:54
 */

package gui;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;
import com.itextpdf.text.pdf.PdfWriter;
import java.awt.Color;
import java.awt.Component;
import java.io.*;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableCellRenderer;
import objectes.assignaturaTipologiaGrup;
import objectes.franjaHoraria;
import objectes.preSolucio;
import objectes.professor;

/**
 *
 * @author z0rskrab
 */
public class VisorResultats extends javax.swing.JDialog {

    private String solucio;
    private String[] resultats;
    private Object[] horari;
    private Object[] perfilProfe;
    private String[] horariATG;
    private String[] assignatures;
    private String[] grups;
    private String tipologies;
    private String[] professors;
    private TaulaHoraris dtl;
    Object[][] auxTaula;
    /** Creates new form NewJDialog */
    public VisorResultats(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
    }

    public VisorResultats(java.awt.Frame parent, boolean modal, String solucio) {
        super(parent, modal);
       
        initComponents();
        this.solucio=solucio.substring(1, solucio.length()-1);
        resultats=this.solucio.replace(",", "").split("\\|");
        List<String> dadesFitxes=llegeixFitxer("./dadespfc.dzn");
        Iterator i=dadesFitxes.iterator();
        String[] horariProfessors = null;
        while (i.hasNext()) {
            String aux=(String) i.next();
            String id[]=aux.split("\\=");
            if (id[0].trim().equals("horarisAssignatures")) {
                horariATG=id[1].substring(2, id[1].length()-3).replace(",", "").split("\\|");
            } else if (id[0].trim().equals("horarisProfessors")) {
                horariProfessors=id[1].substring(2, id[1].length()-3).replace(",", "").split("\\|");
            } else if (id[0].trim().equals("nomGrups")) {
                grups=id[1].substring(1,id[1].length()-1).replace(",","").replace("\"","").split("\\|");
            } else if (id[0].trim().equals("nomAssignatures")) {
                assignatures=id[1].substring(1,id[1].length()-1).replace(",","").replace("\"","").split("\\|");
            } else if (id[0].trim().equals("tipologies")) {
                tipologies=id[1].substring(1,id[1].length()-1).replace(",","");
            } else if (id[0].trim().equals("nomProfessors")) {
                professors=id[1].substring(1,id[1].length()-1).replace(",","").replace("\"","").split("\\|");
            }
        }
        int nfranges=horariATG[0].length();
        int nprofessors=horariProfessors.length;
        int nassignatures=resultats[0].length();
        perfilProfe=new Object[nprofessors];
          int j,k;
          DefaultListModel dlm=new DefaultListModel();
          for (j=0;j<nprofessors;j++) {
              //dlm.addElement(new professor(j,"Professor",""+(j+1)));
              dlm.addElement(new professor(j,professors[j+1],""));
          }
          lstProfes.setModel(dlm);

          for (j=0;j<nprofessors;j++) {
              Object[][] auxHorariProfessor=new Object[nfranges][10];
              for (k=0;k<nfranges;k++) {
                  franjaHoraria aux=new franjaHoraria(k,k/26);
                  if (horariProfessors[j].charAt(k)=='1') { // disponible
                      aux.setMarcat(true);
                  }
                  auxHorariProfessor[k%26][k/26]=aux;
              }
              perfilProfe[j]=auxHorariProfessor;
          }      
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jScrollPane1 = new javax.swing.JScrollPane();
        lstProfes = new javax.swing.JList();
        HorarisGrups = new javax.swing.JTabbedPane();
        jScrollPane3 = new javax.swing.JScrollPane();
        tblHoraris = new javax.swing.JTable();
        jScrollPane6 = new javax.swing.JScrollPane();
        tblHoraris2 = new javax.swing.JTable();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(gui.ProvaApp.class).getContext().getResourceMap(VisorResultats.class);
        jLabel1.setFont(resourceMap.getFont("jLabel1.font")); // NOI18N
        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        jScrollPane1.setName("jScrollPane1"); // NOI18N

        lstProfes.setName("lstProfes"); // NOI18N
        lstProfes.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                lstProfesMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(lstProfes);

        HorarisGrups.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                HorarisGrupsMouseClicked(evt);
            }
        });

        jScrollPane3.setName("jScrollPane3"); // NOI18N

        tblHoraris.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHoraris.setName("tblHoraris"); // NOI18N
        jScrollPane3.setViewportView(tblHoraris);

        HorarisGrups.addTab(resourceMap.getString("jScrollPane3.TabConstraints.tabTitle"), jScrollPane3); // NOI18N

        jScrollPane6.setName("jScrollPane6"); // NOI18N

        tblHoraris2.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {},
                {},
                {},
                {}
            },
            new String [] {

            }
        ));
        tblHoraris2.setName("tblHoraris2"); // NOI18N
        jScrollPane6.setViewportView(tblHoraris2);

        HorarisGrups.addTab(resourceMap.getString("jScrollPane6.TabConstraints.tabTitle"), jScrollPane6); // NOI18N

        jButton1.setText(resourceMap.getString("jButton1.text")); // NOI18N
        jButton1.setName("jButton1"); // NOI18N
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(138, 138, 138)
                .addComponent(jLabel1)
                .addGap(184, 184, 184))
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 239, Short.MAX_VALUE)
                .addGap(6, 6, 6)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButton1, javax.swing.GroupLayout.PREFERRED_SIZE, 155, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addComponent(HorarisGrups, javax.swing.GroupLayout.PREFERRED_SIZE, 495, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(15, 15, 15))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jScrollPane1)
                    .addComponent(HorarisGrups, javax.swing.GroupLayout.DEFAULT_SIZE, 444, Short.MAX_VALUE))
                .addGap(18, 18, 18)
                .addComponent(jButton1)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void HorarisGrupsMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_HorarisGrupsMouseClicked
int quatrimestre=HorarisGrups.getSelectedIndex();
        professor p= (professor) lstProfes.getSelectedValue();
        int nassignatures=resultats[0].length();
        auxTaula=new Object[26][6];
            auxTaula[0][0]="8:00-8:30";
            auxTaula[1][0]="8:30-9:00";
            auxTaula[2][0]="9:00-9:30";
            auxTaula[3][0]="9:30-10:00";
            auxTaula[4][0]="10:00-10:30";
            auxTaula[5][0]="10:30-11:00";
            auxTaula[6][0]="11:00-11:30";
            auxTaula[7][0]="11:30-12:00";
            auxTaula[8][0]="12:00-12:30";
            auxTaula[9][0]="12:30-13:00";
            auxTaula[10][0]="13:00-13:30";
            auxTaula[11][0]="13:30-14:00";
            auxTaula[12][0]="14:00-14:30";
            auxTaula[13][0]="14:30-15:00";
            auxTaula[14][0]="15:00-15:30";
            auxTaula[15][0]="15:30-16:00";
            auxTaula[16][0]="16:00-16:30";
            auxTaula[17][0]="16:30-17:00";
            auxTaula[18][0]="17:00-17:30";
            auxTaula[19][0]="17:30-18:00";
            auxTaula[20][0]="18:00-18:30";
            auxTaula[21][0]="18:30-19:00";
            auxTaula[22][0]="19:00-19:30";
            auxTaula[23][0]="19:30-20:00";
            auxTaula[24][0]="20:00-20:30";
            auxTaula[25][0]="20:30-21:00";
        int i,j,k;
        Object[][] profe=(Object[][]) perfilProfe[p.getId()];
        for (i=0;i<5;i++) {
            for (j=0;j<26;j++) {
                auxTaula[j][i+1]=profe[j][quatrimestre*5+i];
            }
        }

        for (i=0;i<nassignatures;i++) {
              if (resultats[p.getId()].charAt(i)=='1') {
                  for (j=0;j<5;j++) {
                      for (k=0;k<26;k++) {
                          if (horariATG[i].charAt(quatrimestre*130+j*26+k)=='1') auxTaula[k][j+1]=new assignaturaTipologiaGrup(i,assignatures[i],Integer.parseInt(tipologies.substring(i,i+1)),1,grups[i]);
                      }
                  }
              }
          }

        Object[] columnNames=new Object[6];
			columnNames[0]="";
			columnNames[1]="Dilluns";
			columnNames[2]="Dimarts";
			columnNames[3]="Dimecres";
			columnNames[4]="Dijous";
			columnNames[5]="Divendres";
        dtl=new TaulaHoraris(auxTaula,columnNames);
        RenderHoraris render=new RenderHoraris();
        switch (quatrimestre) {
            case 0:
            tblHoraris.setDefaultRenderer(franjaHoraria.class, render);
            tblHoraris.setModel(dtl);
            break;
            case 1:
            tblHoraris2.setDefaultRenderer(franjaHoraria.class, render);
            tblHoraris2.setModel(dtl);
            break;
        }
}//GEN-LAST:event_HorarisGrupsMouseClicked

    private void lstProfesMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_lstProfesMouseClicked
        int quatrimestre=HorarisGrups.getSelectedIndex();
        professor p= (professor) lstProfes.getSelectedValue();
        int nassignatures=resultats[0].length();
            auxTaula=new Object[26][6];
            auxTaula[0][0]="8:00-8:30";
            auxTaula[1][0]="8:30-9:00";
            auxTaula[2][0]="9:00-9:30";
            auxTaula[3][0]="9:30-10:00";
            auxTaula[4][0]="10:00-10:30";
            auxTaula[5][0]="10:30-11:00";
            auxTaula[6][0]="11:00-11:30";
            auxTaula[7][0]="11:30-12:00";
            auxTaula[8][0]="12:00-12:30";
            auxTaula[9][0]="12:30-13:00";
            auxTaula[10][0]="13:00-13:30";
            auxTaula[11][0]="13:30-14:00";
            auxTaula[12][0]="14:00-14:30";
            auxTaula[13][0]="14:30-15:00";
            auxTaula[14][0]="15:00-15:30";
            auxTaula[15][0]="15:30-16:00";
            auxTaula[16][0]="16:00-16:30";
            auxTaula[17][0]="16:30-17:00";
            auxTaula[18][0]="17:00-17:30";
            auxTaula[19][0]="17:30-18:00";
            auxTaula[20][0]="18:00-18:30";
            auxTaula[21][0]="18:30-19:00";
            auxTaula[22][0]="19:00-19:30";
            auxTaula[23][0]="19:30-20:00";
            auxTaula[24][0]="20:00-20:30";
            auxTaula[25][0]="20:30-21:00";
        int i,j,k;
        Object[][] profe=(Object[][]) perfilProfe[p.getId()];
        for (i=0;i<5;i++) {
            for (j=0;j<26;j++) {
                auxTaula[j][i+1]=profe[j][quatrimestre*5+i];
            }
        }

        for (i=0;i<nassignatures;i++) {
              if (resultats[p.getId()].charAt(i)=='1') {
                  for (j=0;j<5;j++) {
                      for (k=0;k<26;k++) {
                          if (horariATG[i].charAt(quatrimestre*130+j*26+k)=='1') auxTaula[k][j+1]=new assignaturaTipologiaGrup(i,assignatures[i],Integer.parseInt(tipologies.substring(i,i+1)),1,grups[i]);
                      }
                  }
              }
          }

        Object[] columnNames=new Object[6];
			columnNames[0]="";
			columnNames[1]="Dilluns";
			columnNames[2]="Dimarts";
			columnNames[3]="Dimecres";
			columnNames[4]="Dijous";
			columnNames[5]="Divendres";
        TaulaHoraris dtl=new TaulaHoraris(auxTaula,columnNames);
        RenderHoraris render=new RenderHoraris();
        switch (quatrimestre) {
            case 0:
            tblHoraris.setDefaultRenderer(franjaHoraria.class, render);
            tblHoraris.setModel(dtl);
            break;
            case 1:
            tblHoraris2.setDefaultRenderer(franjaHoraria.class, render);
            tblHoraris2.setModel(dtl);
            break;
        }
    }//GEN-LAST:event_lstProfesMouseClicked

    private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
        JFileChooser fc=new JFileChooser(".");
        int retrieval = fc.showSaveDialog(null);
        if (retrieval==0) {
            try {
                

                OutputStream file = new FileOutputStream(fc.getSelectedFile());

                Rectangle a4 = PageSize.A4;
                Rectangle a4Landscape = a4.rotate();
                com.itextpdf.text.Document document = new com.itextpdf.text.Document(a4Landscape);
                PdfWriter.getInstance(document, file);
                document.open();
                document.addAuthor("Adrià Vila i Moreno");
                document.addSubject("Elaboració d'horaris");
                document.add(new Paragraph(lstProfes.getSelectedValue().toString()));
                PdfPTable taulaHorari=new PdfPTable(6);
                PdfPCell cantonada=new PdfPCell(new Phrase(""));
                cantonada.setBorderColorTop(BaseColor.WHITE);
                cantonada.setBorderColorLeft(BaseColor.WHITE);
                cantonada.setBorderWidthLeft(0);
                cantonada.setBorderWidthTop(0);
                taulaHorari.addCell(cantonada);
                taulaHorari.addCell("Dilluns");
                taulaHorari.addCell("Dimarts");
                taulaHorari.addCell("Dimecres");
                taulaHorari.addCell("Dijous");
                taulaHorari.addCell("Divendres");

                int i,j;
                for (i=0;i<26;i++) {
                    for (j=0;j<6;j++) {
                        if (auxTaula[i][j] instanceof assignaturaTipologiaGrup) {
                            assignaturaTipologiaGrup atg=(assignaturaTipologiaGrup) auxTaula[i][j];
                            PdfPCell complexcell=new PdfPCell(new Phrase(atg.getNom()+"->"+atg.getNomGrup()));
                            //complexcell.setBorderColor(colorTipologia(atg.getTipologia()));
                            complexcell.setBackgroundColor(colorTipologia(atg.getTipologia()));
                            taulaHorari.addCell(complexcell);
                        } else taulaHorari.addCell(auxTaula[i][j].toString());
                        //taulaHorari.addCell(i+"-"+j);
                    }
               }
                document.add(taulaHorari);
                document.close();
                file.close();

            } catch (Exception e) {
            }
        }
    }//GEN-LAST:event_jButton1ActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                VisorResultats dialog = new VisorResultats(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    private List<String> llegeixFitxer(String ruta) {
        List<String> records = new ArrayList<String>();
  try
  {
    BufferedReader reader = new BufferedReader(new FileReader(ruta));
    String line;
    while ((line = reader.readLine()) != null)
    {
      records.add(line);
    }
    reader.close();
    return records;
  }
  catch (Exception e)
  {
    System.err.format("Exception occurred trying to read '%s'.", ruta);
    e.printStackTrace();
    return null;
  }
}
    private BaseColor colorTipologia(int tipologia) {
            switch(tipologia) {
			case 0:
				return com.itextpdf.text.BaseColor.GRAY;
			case 1:
				return com.itextpdf.text.BaseColor.ORANGE;

			case 2:
				return com.itextpdf.text.BaseColor.GREEN;
			case 3:
				return com.itextpdf.text.BaseColor.YELLOW;
		}
		return null;
        }

    public class TaulaHoraris extends DefaultTableModel {
		private TaulaHoraris(Object[][] lstProfessors, Object[] columnNames) {
			super(lstProfessors,columnNames);
		}
		@Override
			public Class getColumnClass(int columna) {
				if (columna == 0) return String.class;
				return franjaHoraria.class;
			}
	}

    public class RenderHoraris extends JLabel implements TableCellRenderer {

		public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
			JLabel Etiq=new JLabel();
			Etiq.setHorizontalAlignment(CENTER);
			if (value instanceof preSolucio) {
                                preSolucio x=(preSolucio)value;
                                professor px=x.getProfessor();
                                Etiq.setToolTipText("Grup Preassignat a "+px.toString());
                                Etiq.setOpaque(true);
				Etiq.setBackground(Color.RED);
				Etiq.setText("Preassignat");
				return Etiq;
                        } else if (value instanceof franjaHoraria) {
				franjaHoraria x = (franjaHoraria) value;
				if (x.getMarcat()==true) {
					Etiq.setOpaque(true);
					Etiq.setBackground(Color.BLUE);
					return Etiq;
				} else return null;
			} else if (value instanceof assignaturaTipologiaGrup) {
				assignaturaTipologiaGrup x = (assignaturaTipologiaGrup)value;
				Etiq.setOpaque(true);
				Etiq.setBackground(colorTipologia(x.getTipologia()));
				Etiq.setText(x.getNomGrup());
				Etiq.setToolTipText(x.getNomGrup());
				return Etiq;
			} else if (value instanceof ArrayList) {
				ArrayList x = (ArrayList) value;
				int i, len=x.size();
				String text="";
				for (i=0;i<len;i++) {
                                        if (x.get(i) instanceof assignaturaTipologiaGrup) {
                                            assignaturaTipologiaGrup aux=(assignaturaTipologiaGrup) x.get(i);
                                            if (text.equals("")) {
                                                text=aux.getNomGrup();
                                                Etiq.setToolTipText("<html><body>Grup "+aux.getNomGrup());
                                            } else {
                                                text+=" / "+aux.getNomGrup();
                                                Etiq.setToolTipText(Etiq.getToolTipText()+"<br />Grup "+aux.getNomGrup());
                                            }
                                        } else {
                                            preSolucio aux2=(preSolucio) x.get(i);
                                            if (text.equals("")) {
                                                text=aux2.getAtg().getNomGrup();
                                                Etiq.setToolTipText("<html><body>Grup donat per "+aux2.getProfessor().toString());
                                            } else {
                                                Etiq.setToolTipText(Etiq.getToolTipText()+"<br />Grup donat per "+aux2.getProfessor().toString());
                                                text+=" / "+aux2.getAtg().getNomGrup();
                                            }
                                        }
				}
				Etiq.setText(text);
                                Etiq.setToolTipText(Etiq.getToolTipText()+"</body></html>");
				Etiq.setOpaque(true);
				return Etiq;
			} else return null;
		}

        private Color colorTipologia(int tipologia) {
            switch(tipologia) {
			case 0:
				return Color.GRAY;
			case 1:
				return Color.ORANGE;
			case 2:
				return Color.GREEN;
			case 3:
				return Color.YELLOW;
		}
		return null;
        }
	}

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane HorarisGrups;
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JScrollPane jScrollPane6;
    private javax.swing.JList lstProfes;
    private javax.swing.JTable tblHoraris;
    private javax.swing.JTable tblHoraris2;
    // End of variables declaration//GEN-END:variables

}
