/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.ResultSet;
import java.sql.Statement;
import objectes.assignaturaTipologia;

/**
 *
 * @author z0rskrab
 */
public class bdd_assignatures_tipologia {
    public static Object[] selectAll(connect con) {
        Statement stmt=null;
        assignaturaTipologia[] assignaturesTipologia=null;
        assignaturaTipologia aux;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia.t_assignatura_id and t_assignatura_tipologia_ncredits>0";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            //ResultSet rs=stmt.executeQuery("SELECT * FROM t_assignatures_tipologia,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia.t_assignatura_id and t_assignatura_tipologia_ncredits>0");
            rs.last();
            int nreg=rs.getRow();
            assignaturesTipologia=new assignaturaTipologia[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologia(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"));
                assignaturesTipologia[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologia;
    }

    public static Object[] selectById(connect con,int id) {
        assignaturaTipologia[] assignaturesTipologia=null;
        assignaturaTipologia aux;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia.t_assignatura_id and t_assignatura_tipologia_ncredits>0 and t_assignatures_tipologia.t_assignatura_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, id);
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            assignaturesTipologia=new assignaturaTipologia[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologia(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"));
                aux.setNcredits(rs.getInt("t_assignatura_tipologia_ncredits"));
                assignaturesTipologia[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologia;
    }

    public static void updateTipologia(connect con, int id, int idTipologia, int nCredits) {
        assignaturaTipologia[] assignaturesTipologia=null;
        try {
            String sql="INSERT into t_assignatures_tipologia(t_assignatura_id,t_tipologia_id,t_assignatura_tipologia_ncredits) values (?,?,?) ON DUPLICATE KEY UPDATE t_assignatura_tipologia_ncredits=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, id);
            pStmt.setInt(2, idTipologia);
            pStmt.setInt(3, nCredits);
            pStmt.setInt(4, nCredits);
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }

    }

    public static assignaturaTipologia[] getTipologiesById(connect con, int id) {
        assignaturaTipologia[] assignaturesTipologia=null;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia WHERE t_assignatura_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, id);
            ResultSet rs=pStmt.executeQuery();
            assignaturesTipologia=new assignaturaTipologia[4];
            while (rs.next()) {
                assignaturaTipologia x = new assignaturaTipologia(id,null,rs.getInt("t_tipologia_id"),rs.getInt("t_assignatura_tipologia_ncredits"));
                assignaturesTipologia[rs.getInt("t_tipologia_id")]=x;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologia;
    }

    public static void deleteTipologia(connect con, assignaturaTipologia at) {
        try {
            String sql_hg="delete from t_horaris_grups where t_assignatura_id=? and t_tipologia_id=?";
            String sql_atg="delete from t_assignatures_tipologia_grup where t_assignatura_id=? and t_tipologia_id=?";
            String sql_at="update t_assignatures_tipologia set t_assignatura_tipologia_ncredits=0 where t_assignatura_id=? and t_tipologia_id=?";
            String sql_a="update t_assignatures set t_assignatura_ncredits=(select sum(t_assignatura_tipologia_ncredits) from t_assignatures_tipologia where t_assignatura_id=?) where t_assignatura_id=?";
            String sql_c="delete from t_capacitacions where t_assignatura_id=? and t_assignatura_tipologia_id=?";
            PreparedStatement pStmt_hg=con.getConn().prepareStatement(sql_hg);
            PreparedStatement pStmt_atg=con.getConn().prepareStatement(sql_atg);
            PreparedStatement pStmt_at=con.getConn().prepareStatement(sql_at);
            PreparedStatement pStmt_a=con.getConn().prepareStatement(sql_a);
            PreparedStatement pStmt_c=con.getConn().prepareStatement(sql_c);
            pStmt_hg.setInt(1,at.getId());
            pStmt_hg.setInt(2,at.getTipologia());
            pStmt_atg.setInt(1, at.getId());
            pStmt_atg.setInt(2, at.getTipologia());
            pStmt_at.setInt(1, at.getId());
            pStmt_at.setInt(2, at.getTipologia());
            pStmt_a.setInt(1, at.getId());
            pStmt_a.setInt(2, at.getId());
            pStmt_c.setInt(1, at.getId());
            pStmt_c.setInt(2, at.getTipologia());
            int rs_hg=pStmt_hg.executeUpdate();
            int rs_atg=pStmt_atg.executeUpdate();
            int rs_at=pStmt_at.executeUpdate();
            int rs_a=pStmt_a.executeUpdate();
            int rs_c=pStmt_c.executeUpdate();
       } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
