/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.sql.ResultSet;
import java.sql.Statement;
import objectes.assignaturaTipologia;
import objectes.assignaturaTipologiaGrup;

/**
 *
 * @author z0rskrab
 */
public class bdd_assignatures_tipologia_grup {
    public static Object[] selectAll(connect con) {
        Statement stmt=null;
        assignaturaTipologia[] assignaturesTipologia=null;
        assignaturaTipologia aux;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia_grup,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            //ResultSet rs=stmt.executeQuery("SELECT * FROM t_assignatures_tipologia_grup,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia.t_assignatura_id");
            rs.last();
            int nreg=rs.getRow();
            assignaturesTipologia=new assignaturaTipologia[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologia(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"));
                assignaturesTipologia[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia_grup.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologia;
    }
    
    public static Object[] selectAllGrups(connect con) {
        Statement stmt=null;
        assignaturaTipologiaGrup[] assignaturesTipologiaGrups=null;
        assignaturaTipologiaGrup aux;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia_grup,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            //ResultSet rs=stmt.executeQuery("SELECT * FROM t_assignatures_tipologia_grup,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia.t_assignatura_id");
            rs.last();
            int nreg=rs.getRow();
            assignaturesTipologiaGrups=new assignaturaTipologiaGrup[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),rs.getString("t_grup_nom"));
                assignaturesTipologiaGrups[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia_grup.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologiaGrups;
    }

    public static Object[] selectById(connect con,int id, int idTipologia) {
        assignaturaTipologiaGrup[] assignaturesTipologiaGrup=null;
        assignaturaTipologiaGrup aux;
        try {
            String sql="SELECT * FROM t_assignatures_tipologia_grup,t_assignatures WHERE t_assignatures.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_assignatures_tipologia_grup.t_tipologia_id=? and t_assignatures_tipologia_grup.t_assignatura_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idTipologia);
            pStmt.setInt(2, id);
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            assignaturesTipologiaGrup=new assignaturaTipologiaGrup[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),rs.getString("t_grup_nom"));
                assignaturesTipologiaGrup[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia_grup.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignaturesTipologiaGrup;
    }

        public static void afegirGrup(connect con, int idAssignatura, int idTipologia, String nomGrup){
        try {
            String sql="INSERT into t_assignatures_tipologia_grup(t_assignatura_id,t_tipologia_id,t_grup_nom) values(?,?,?)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, idAssignatura);
            pStmt.setInt(2, idTipologia);
            pStmt.setString(3, nomGrup);
            int rs=pStmt.executeUpdate();
         } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void updateGrup(connect con, assignaturaTipologiaGrup g) {
        try {
            String sql="update t_assignatures_tipologia_grup set t_grup_nom=? where t_assignatura_id=? and t_tipologia_id=? and t_grup_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setString(1, g.getNomGrup());
            pStmt.setInt(2, g.getId());
            pStmt.setInt(3, g.getTipologia());
            pStmt.setInt(4, g.getGrup());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void deleteGrup(connect con, assignaturaTipologiaGrup g) {
        try {
            String sql_hg="delete from t_horaris_grups where t_assignatura_id=? and t_tipologia_id=? and t_grup_id=?";
            String sql_atg="delete from t_assignatures_tipologia_grup where t_assignatura_id=? and t_tipologia_id=? and t_grup_id=?";
            PreparedStatement pStmt_hg=con.getConn().prepareStatement(sql_hg);
            PreparedStatement pStmt_atg=con.getConn().prepareStatement(sql_atg);
            pStmt_hg.setInt(1, g.getId());
            pStmt_hg.setInt(2, g.getTipologia());
            pStmt_hg.setInt(3, g.getGrup());
            pStmt_atg.setInt(1, g.getId());
            pStmt_atg.setInt(2, g.getTipologia());
            pStmt_atg.setInt(3, g.getGrup());
            int rs_hg=pStmt_hg.executeUpdate();
            int rs_atg=pStmt_atg.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures_tipologia.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
