/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import objectes.assignatura;
import objectes.assignaturaTipologia;
import objectes.assignaturaTipologiaGrup;
import objectes.franjaHoraria;
import objectes.preSolucio;
import objectes.professor;
import java.util.TreeSet;

/**
 *
 * @author z0rskrab
 */
public class bdd_franja_horaria {
    public static Object[][] selectAll(connect con) {
        Object[][] horari=null;
        franjaHoraria aux;
        try {
            String sql="select * from t_franja_horaria order by t_franja_horaria_dia, t_franja_horaria_inici, t_franja_horaria_final";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            int nregperdia=nreg/5;
            horari=new Object[nregperdia][6];
            horari[0][0]="8:00-8:30";
            horari[1][0]="8:30-9:00";
            horari[2][0]="9:00-9:30";
            horari[3][0]="9:30-10:00";
            horari[4][0]="10:00-10:30";
            horari[5][0]="10:30-11:00";
            horari[6][0]="11:00-11:30";
            horari[7][0]="11:30-12:00";
            horari[8][0]="12:00-12:30";
            horari[9][0]="12:30-13:00";
            horari[10][0]="13:00-13:30";
            horari[11][0]="13:30-14:00";
            horari[12][0]="14:00-14:30";
            horari[13][0]="14:30-15:00";
            horari[14][0]="15:00-15:30";
            horari[15][0]="15:30-16:00";
            horari[16][0]="16:00-16:30";
            horari[17][0]="16:30-17:00";
            horari[18][0]="17:00-17:30";
            horari[19][0]="17:30-18:00";
            horari[20][0]="18:00-18:30";
            horari[21][0]="18:30-19:00";
            horari[22][0]="19:00-19:30";
            horari[23][0]="19:30-20:00";
            horari[24][0]="20:00-20:30";
            horari[25][0]="20:30-21:00";

            rs.beforeFirst();
            int count=0, actual;
            while (rs.next()) {
                aux=new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final"));
                horari[count%nregperdia][(int)((Math.ceil(count/nregperdia))+1)]=aux;
                count++;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return horari;
    }

    public static Object[] selectAllFranges(connect con) {
        Object[] horari=null;
        franjaHoraria aux;
        try {
            String sql="select * from t_franja_horaria order by t_franja_horaria_dia, t_franja_horaria_inici, t_franja_horaria_final";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            rs.beforeFirst();
            horari=new Object[nreg];
            int count=0, actual;
            while (rs.next()) {
                aux=new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final"));
                horari[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }

        return horari;
    }

    public static HashMap<assignaturaTipologiaGrup,TreeSet> selectPresolucions(connect con, professor p) {
        HashMap<assignaturaTipologiaGrup,TreeSet> presolucions=new HashMap<assignaturaTipologiaGrup,TreeSet>();
        //String sql="select t_horaris_grups.* from t_horaris_grups, t_capacitacions where t_horaris_grups.t_assignatura_id=t_capacitacions.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_capacitacions.t_assignatura_tipologia_id and t_professor_id=? and (t_horaris_grups.t_assignatura_id,t_horaris_grups.t_tipologia_id,t_horaris_grups.t_grup_id) not in (select t_assignatura_id,t_tipologia_id,t_grup_id from t_presolucions) order by t_assignatura_id,t_tipologia_id,t_grup_id,t_franja_horaria_id";
        String sql="select t_horaris_grups.*,t_assignatura_nom, t_grup_nom from t_horaris_grups, t_capacitacions, t_assignatures, t_assignatures_tipologia_grup where  t_assignatures_tipologia_grup.t_assignatura_id=t_horaris_grups.t_assignatura_id and t_assignatures_tipologia_grup.t_tipologia_id=t_horaris_grups.t_tipologia_id and t_assignatures_tipologia_grup.t_grup_id=t_horaris_grups.t_grup_id and t_assignatures.t_assignatura_id=t_horaris_grups.t_assignatura_id and t_horaris_grups.t_assignatura_id=t_capacitacions.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_capacitacions.t_assignatura_tipologia_id and t_professor_id=? and (t_horaris_grups.t_assignatura_id,t_horaris_grups.t_tipologia_id,t_horaris_grups.t_grup_id) not in (select t_assignatura_id,t_tipologia_id,t_grup_id from t_presolucions) order by t_horaris_grups.t_assignatura_id,t_tipologia_id,t_grup_id,t_franja_horaria_id";
        PreparedStatement pStmt=null;
                try {
                        pStmt=con.getConn().prepareStatement(sql);
                        pStmt.setInt(1, p.getId());
                        ResultSet rs=pStmt.executeQuery();
                        int i=0;
                        TreeSet aux;
                        while (rs.next()) {
                           assignaturaTipologiaGrup atg=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),rs.getString("t_grup_nom"));
                           if (presolucions.get(atg)!=null) {
                                aux=presolucions.get(atg);
                                aux.add(new Integer(rs.getInt("t_franja_horaria_id")));
                                //presolucions.put(atg, null);
                           } else {
                                aux=new TreeSet();
                                aux.add(new Integer(rs.getInt("t_franja_horaria_id")));
                                presolucions.put(atg, aux);
                           }
                        }
                } catch (SQLException ex) {
                    Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
                }
        return presolucions;
    }

    public static Object[] selectHoresLliures(connect con, professor p, int quatrimestre) {
        Object[] lliures=new Object[130];
        int i;
        for (i=0;i<130;i++) lliures[i]=0;
        PreparedStatement pStmt=null;
        //String sql="select t_franja_horaria_id from t_horaris_professors where t_franja_horaria_id not in (select t_franja_horaria_id from t_horaris_grups,t_presolucions where t_horaris_grups.t_assignatura_id=t_presolucions.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_presolucions.t_tipologia_id and t_horaris_grups.t_grup_id=t_presolucions.t_grup_id and t_quatrimestre=?) and t_professor_id=?";
        String sql="select t_franja_horaria_id from t_horaris_professors where t_quatrimestre=? and t_professor_id=?";
        try {
                    pStmt=con.getConn().prepareStatement(sql);
                    pStmt.setInt(1, quatrimestre);
                    pStmt.setInt(2, p.getId());
                    ResultSet rs=pStmt.executeQuery();
                    while (rs.next()) {
                        int index=Integer.parseInt(rs.getString("t_franja_horaria_id"));
                        lliures[index-1]=1;
                    }
            } catch (SQLException ex) {
                    Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
        return lliures;
    }
    
    public static Object[] selectHoresLliures(connect con, assignaturaTipologiaGrup atg, int quatrimestre) {
        Object[] lliures=new Object[130];
        int i;
        for (i=0;i<130;i++) lliures[i]=0;
        PreparedStatement pStmt=null;
        //String sql="select t_franja_horaria_id from t_horaris_grups where t_franja_horaria_id not in (select t_franja_horaria_id from t_horaris_grups,t_presolucions where t_horaris_grups.t_assignatura_id=t_presolucions.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_presolucions.t_tipologia_id and t_horaris_grups.t_grup_id=t_presolucions.t_grup_id) and t_assignatura_id=? and t_tipologia_id=? and t_grup_id=?";
            String sql="select t_franja_horaria_id from t_horaris_grups where t_assignatura_id=? and t_tipologia_id=? and t_grup_id=? and t_quatrimestre=?";
            try {
                    pStmt=con.getConn().prepareStatement(sql);
                    pStmt.setInt(1, atg.getId());
                    pStmt.setInt(2, atg.getTipologia());
                    pStmt.setInt(3, atg.getGrup());
                    pStmt.setInt(4, quatrimestre);
                    ResultSet rs=pStmt.executeQuery();
                    while (rs.next()) {
                        int index=Integer.parseInt(rs.getString("t_franja_horaria_id"));
                        lliures[index-1]=1;
                    }
            } catch (SQLException ex) {
                    Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
        return lliures;
    }
    
    public static Object[][] selectPersonalitzat(connect con, Object obj, int quatrimestre) {
                Object[][] horari=null;
                PreparedStatement pStmt=null, pStmt2=null;
                HashMap<String,preSolucio> grupsPreAssignats=new HashMap<String,preSolucio>();
                HashMap<Integer,preSolucio> professorsPreAssignats=new HashMap<Integer,preSolucio>();
            if (obj instanceof assignaturaTipologiaGrup) {
            try {
                String sql = "select distinct t_franja_horaria.*,t2.*, not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select * from t_horaris_grups where t_grup_id=? and t_tipologia_id=? and t_assignatura_id=? and t_quatrimestre=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_id";
                pStmt = con.getConn().prepareStatement(sql);
                pStmt.setInt(1, ((assignaturaTipologiaGrup) obj).getGrup());
                pStmt.setInt(2, ((assignaturaTipologiaGrup) obj).getTipologia());
                pStmt.setInt(3, ((assignaturaTipologiaGrup) obj).getId());
                pStmt.setInt(4, quatrimestre);
            } catch (SQLException ex) {
                Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
            } else if (obj instanceof assignaturaTipologia) {
            try {
                String sql = "select *, not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select t_assignatures_tipologia_grup.*,t_franja_horaria_id from t_horaris_grups, t_assignatures_tipologia_grup where t_horaris_grups.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_horaris_grups.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_horaris_grups.t_tipologia_id=? and t_horaris_grups.t_assignatura_id=? and t_quatrimestre=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_dia,t_franja_horaria.t_franja_horaria_inici, t_tipologia_id,t_grup_id";
                pStmt = con.getConn().prepareStatement(sql);
                pStmt.setInt(1, ((assignaturaTipologia) obj).getTipologia());
                pStmt.setInt(2, ((assignaturaTipologia) obj).getId());
                pStmt.setInt(3, quatrimestre);
            } catch (SQLException ex) {
                Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
            } else if (obj instanceof assignatura) {
            try {
                String sql = "select *, not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select t_assignatures_tipologia_grup.*,t_franja_horaria_id from t_horaris_grups, t_assignatures_tipologia_grup where t_horaris_grups.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_horaris_grups.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_horaris_grups.t_assignatura_id=? and t_quatrimestre=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_dia,t_franja_horaria.t_franja_horaria_inici,t_assignatura_id,t_tipologia_id,t_grup_id";
                pStmt = con.getConn().prepareStatement(sql);
                pStmt.setInt(1, ((assignatura) obj).getId());
                pStmt.setInt(2, quatrimestre);
            } catch (SQLException ex) {
                Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
            } else if (obj instanceof professor) {
            try {
                String sql = "select distinct t_franja_horaria.*, not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select * from t_horaris_professors where t_professor_id=? and t_quatrimestre=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_id";
                //String sql="select distinct t_franja_horaria.*, t2.*,  not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select t_horaris_professors.*,t_professor_nom,t_professor_cognom from t_horaris_professors, t_professors where t_horaris_professors.t_professor_id=t_professors.t_professor_id and t_horaris_professors.t_professor_id=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_id";
                //String sql="select distinct t_franja_horaria.*, t2.*,  not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select t_horaris_professors.*,t_professor_nom,t_professor_cognom, t_presolucions.t_assignatura_id, t_presolucions.t_tipologia_id, t_presolucions.t_grup_id, t_grup_nom, t_assignatura_nom from t_horaris_professors, t_professors, t_presolucions, t_assignatures_tipologia_grup, t_assignatures where t_assignatures.t_assignatura_id=t_presolucions.t_assignatura_id and t_assignatures_tipologia_grup.t_assignatura_id=t_presolucions.t_assignatura_id and t_assignatures_tipologia_grup.t_tipologia_id=t_presolucions.t_tipologia_id and t_assignatures_tipologia_grup.t_grup_id=t_presolucions.t_grup_id and t_horaris_professors.t_professor_id=t_professors.t_professor_id and t_horaris_professors.t_professor_id=t_professors.t_professor_id and t_presolucions.t_professor_id=t_professors.t_professor_id and t_horaris_professors.t_professor_id=?) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id) order by t_franja_horaria.t_franja_horaria_id";
                //String sql="select distinct t_franja_horaria.*, t2.*,  not isnull(t2.t_franja_horaria_id) as disponible from t_franja_horaria left outer join (select t_presolucions.*, t_horaris_professors.t_franja_horaria_id from t_horaris_grups, t_horaris_professors, t_presolucions where t_presolucions.t_professor_id=t_horaris_professors.t_professor_id and t_horaris_grups.t_assignatura_id=t_presolucions.t_assignatura_id and t_horaris_grups.t_tipologia_id=t_presolucions.t_tipologia_id and t_horaris_grups.t_grup_id=t_presolucions.t_grup_id and t_horaris_grups.t_franja_horaria_id=t_horaris_professors.t_franja_horaria_id and t_horaris_professors.t_professor_id=? group by t_horaris_professors.t_franja_horaria_id) as t2 on (t_franja_horaria.t_franja_horaria_id=t2.t_franja_horaria_id)";
                pStmt = con.getConn().prepareStatement(sql);
                pStmt.setInt(1, ((professor) obj).getId());
                pStmt.setInt(2, quatrimestre);
            } catch (SQLException ex) {
                Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
            }
            }
        try {
            // Carreguem presolucions en un hashmap, per poder accedir facilment i en cost constant a cerques i tal.
            if (obj instanceof professor) {
                String sql2 = "select t_presolucions.*, t_horaris_grups.t_franja_horaria_id, t_professor_nom, t_professor_cognom, t_assignatura_nom, t_grup_nom from t_presolucions, t_horaris_grups, t_professors, t_assignatures, t_assignatures_tipologia_grup where t_presolucions.t_assignatura_id=t_horaris_grups.t_assignatura_id and t_presolucions.t_tipologia_id=t_horaris_grups.t_tipologia_id and t_presolucions.t_grup_id=t_horaris_grups.t_grup_id and t_professors.t_professor_id=t_presolucions.t_professor_id and t_assignatures.t_assignatura_id=t_presolucions.t_assignatura_id and t_presolucions.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_presolucions.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_presolucions.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_presolucions.t_professor_id=? and t_quatrimestre=?";
                pStmt2 = con.getConn().prepareStatement(sql2);
                pStmt2.setInt(1, ((professor)obj).getId());
                pStmt2.setInt(2, quatrimestre);
                ResultSet rs2=pStmt2.executeQuery();
                while (rs2.next()) {
                        //assignaturaTipologiaGrup atg=new assignaturaTipologiaGrup(rs2.getInt("t_assignatura_id"),rs2.getString("t_assignatura_nom"),rs2.getInt("t_tipologia_id"),rs2.getInt("t_grup_id"),rs2.getString("t_grup_nom"));
                        assignaturaTipologiaGrup atg=new assignaturaTipologiaGrup(rs2.getInt("t_assignatura_id"),rs2.getString("t_assignatura_nom"),rs2.getInt("t_tipologia_id"),rs2.getInt("t_grup_id"),rs2.getString("t_grup_nom"));
                        Integer key=rs2.getInt("t_franja_horaria_id");
                        professor p=new professor(rs2.getInt("t_professor_id"),rs2.getString("t_professor_nom"),rs2.getString("t_professor_cognom"));
                        professorsPreAssignats.put(key, new preSolucio(p,atg));
                    }
            } else {
                String sql2 = "select t_presolucions.*,t_professors.*,t_assignatures_tipologia_grup.*,t_assignatures.* from t_presolucions, t_horaris_grups, t_professors, t_assignatures_tipologia_grup, t_assignatures where t_presolucions.t_assignatura_id=t_horaris_grups.t_assignatura_id and t_presolucions.t_tipologia_id=t_horaris_grups.t_tipologia_id and t_presolucions.t_grup_id=t_horaris_grups.t_grup_id and t_presolucions.t_professor_id=t_professors.t_professor_id and t_presolucions.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_presolucions.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_presolucions.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_assignatures.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id group by t_presolucio_id";
                pStmt2 = con.getConn().prepareStatement(sql2);
                ResultSet rs2=pStmt2.executeQuery();
                while (rs2.next()) {
                        //assignaturaTipologiaGrup atg=new assignaturaTipologiaGrup(rs2.getInt("t_assignatura_id"),rs2.getString("t_assignatura_nom"),rs2.getInt("t_tipologia_id"),rs2.getInt("t_grup_id"),rs2.getString("t_grup_nom"));
                        assignaturaTipologiaGrup atg=new assignaturaTipologiaGrup(rs2.getInt("t_assignatura_id"),rs2.getString("t_assignatura_nom"),rs2.getInt("t_tipologia_id"),rs2.getInt("t_grup_id"),rs2.getString("t_grup_nom"));
                        String key=rs2.getInt("t_assignatura_id")+"#"+rs2.getInt("t_tipologia_id")+"#"+rs2.getInt("t_grup_id");
                        professor p=new professor(rs2.getInt("t_professor_id"),rs2.getString("t_professor_nom"),rs2.getString("t_professor_cognom"));
                        grupsPreAssignats.put(key, new preSolucio(p,atg));
                    }
            }
        } catch (SQLException ex) {
            Logger.getLogger(bdd_franja_horaria.class.getName()).log(Level.SEVERE, null, ex);
        }
            try {
                    ResultSet rs=pStmt.executeQuery();
                    rs.last();
                    int nreg=130;
                    int nregperdia=nreg/5;
                    horari=new Object[nregperdia][6];
                    horari[0][0]="8:00-8:30";
                    horari[1][0]="8:30-9:00";
                    horari[2][0]="9:00-9:30";
                    horari[3][0]="9:30-10:00";
                    horari[4][0]="10:00-10:30";
                    horari[5][0]="10:30-11:00";
                    horari[6][0]="11:00-11:30";
                    horari[7][0]="11:30-12:00";
                    horari[8][0]="12:00-12:30";
                    horari[9][0]="12:30-13:00";
                    horari[10][0]="13:00-13:30";
                    horari[11][0]="13:30-14:00";
                    horari[12][0]="14:00-14:30";
                    horari[13][0]="14:30-15:00";
                    horari[14][0]="15:00-15:30";
                    horari[15][0]="15:30-16:00";
                    horari[16][0]="16:00-16:30";
                    horari[17][0]="16:30-17:00";
                    horari[18][0]="17:00-17:30";
                    horari[19][0]="17:30-18:00";
                    horari[20][0]="18:00-18:30";
                    horari[21][0]="18:30-19:00";
                    horari[22][0]="19:00-19:30";
                    horari[23][0]="19:30-20:00";
                    horari[24][0]="20:00-20:30";
                    horari[25][0]="20:30-21:00";
                    rs.beforeFirst();
                    if (obj instanceof assignaturaTipologiaGrup) {
                                    int count=0, actual;
                                    Object aux;
                                    while (rs.next()) {
                                        String key=rs.getInt("t_assignatura_id")+"#"+rs.getInt("t_tipologia_id")+"#"+rs.getInt("t_grup_id");
                                        if (grupsPreAssignats.containsKey(key)) {
                                            aux=new preSolucio(grupsPreAssignats.get(key));
                                            ((preSolucio)aux).setFranja(new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final")));
                                        } else {
                                            aux=new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final"));
                                            if(rs.getInt("disponible")==1) ((franjaHoraria)aux).setMarcat(true);
                                        }

                                        horari[count%nregperdia][(int)((Math.ceil(count/nregperdia))+1)]=aux;
                                        count++;
                                    }
                        } else if (obj instanceof assignaturaTipologia || obj instanceof assignatura) {
                                    rs.beforeFirst();
                                    int count=0, actual,idAss,idTip,idGrup,x_act,y_act;
                                    Object aux;
                                    String nomGrup;
                                    ArrayList x;
                                    while (rs.next()) {
                                        idAss=rs.getInt("t_assignatura_id");
                                        idTip=rs.getInt("t_tipologia_id");
                                        idGrup=rs.getInt("t_grup_id");
                                        nomGrup=rs.getString("t_grup_nom");
                                        String key=rs.getInt("t_assignatura_id")+"#"+rs.getInt("t_tipologia_id")+"#"+rs.getInt("t_grup_id");
                                        if (grupsPreAssignats.containsKey(key)) {
                                            aux=new preSolucio(grupsPreAssignats.get(key));
                                            ((preSolucio)aux).setFranja(new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final")));
                                        } else {
                                            if (rs.getInt("disponible")==0) aux=null;
                                            else aux=new assignaturaTipologiaGrup(idAss,null,idTip,idGrup,nomGrup);
                                        }
                                        x_act=((rs.getInt("t_franja_horaria_inici")-28800)/1800);
                                        y_act=rs.getInt("t_franja_horaria_dia")+1;
                                        if (horari[x_act][y_act]==null) {
                                            horari[x_act][y_act]=aux;
                                        } else if (horari[x_act][y_act] instanceof assignaturaTipologiaGrup || horari[x_act][y_act] instanceof preSolucio) {
                                            x=new ArrayList();
                                            x.add(horari[x_act][y_act]);
                                            x.add(aux);
                                            horari[x_act][y_act]=x;
                                        } else if (horari[x_act][y_act] instanceof ArrayList) {
                                            x=(ArrayList) horari[x_act][y_act];
                                            x.add(aux);
                                        }

                                    }
                        } else  if (obj instanceof professor) {
                                    int count=0, actual;
                                    Object aux;
                                    while (rs.next()) {
                                        //assignaturaTipologiaGrup comp=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),null,rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),null);
                                        //Integer key=rs.getInt("t_professor_id");
                                        Integer key=rs.getInt("t_franja_horaria_id");
                                        if (professorsPreAssignats.containsKey(key)) {
                                            aux=new preSolucio(professorsPreAssignats.get(key));
                                            franjaHoraria fj=new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final"));
                                             ((preSolucio)aux).setFranja(fj);
                                        } else {
                                            aux=new franjaHoraria(rs.getInt("t_franja_horaria_id"),rs.getInt("t_franja_horaria_dia"),rs.getInt("t_franja_horaria_inici"),rs.getInt("t_franja_horaria_final"));
                                            if(rs.getInt("disponible")==1) ((franjaHoraria)aux).setMarcat(true);
                                        }

                                        horari[count%nregperdia][(int)((Math.ceil(count/nregperdia))+1)]=aux;
                                        count++;
                                    }
                        }
                    rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }
                return horari;
    }

public static void actualitzaHoraris(connect con, assignaturaTipologiaGrup obtAssignaturaSeleccionada, Vector<Integer> frangesDel, Vector<Integer> frangesAdd, int quatrimestre) {
        Object[][] horari=null;
        franjaHoraria aux;
        int i;
        String union = "";
        assignaturaTipologiaGrup x=(assignaturaTipologiaGrup) obtAssignaturaSeleccionada;
        try {
            if (!frangesAdd.isEmpty()) {
                if (frangesAdd.size()>0) {
                    for (i=1;i<frangesAdd.size();i++) {
                        union+=" union all select ?,?,?,?,?";
                    }
                String sql="insert into t_horaris_grups(t_grup_id,t_assignatura_id, t_tipologia_id,t_franja_horaria_id, t_quatrimestre) select ?,?,?,?,?"+union;
                PreparedStatement pStmt=con.getConn().prepareStatement(sql);

                for (i=0;i<frangesAdd.size();i++) {
                    pStmt.setInt(i*5+1, x.getGrup());
                    pStmt.setInt(i*5+2, x.getId());
                    pStmt.setInt(i*5+3, x.getTipologia());
                    pStmt.setInt(i*5+4, frangesAdd.elementAt(i));
                    pStmt.setInt(i*5+5, quatrimestre);
                }
                int rs=pStmt.executeUpdate();
                }
            }
            union="";
            if (!frangesDel.isEmpty()) {
                if (frangesDel.size()>0) {
                    for (i=1;i<frangesDel.size();i++) {
                        union+=" or (t_grup_id=? and t_assignatura_id=? and t_tipologia_id=? and t_franja_horaria_id=? and t_quatrimestre=?)";
                    }
                    String sql2="delete from t_horaris_grups where (t_grup_id=? and t_assignatura_id=? and t_tipologia_id=? and t_franja_horaria_id=? and t_quatrimestre=?)"+union;
                    PreparedStatement pStmt2=con.getConn().prepareStatement(sql2);
                for (i=0;i<frangesDel.size();i++) {
                    pStmt2.setInt(i*5+1, x.getGrup());
                    pStmt2.setInt(i*5+2, x.getId());
                    pStmt2.setInt(i*5+3, x.getTipologia());
                    pStmt2.setInt(i*5+4, frangesDel.elementAt(i));
                    pStmt2.setInt(i*5+5, quatrimestre);
                }
                int rs=pStmt2.executeUpdate();
                }
            }
            
        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public static void actualitzaHoraris(connect con, professor p, Vector<Object> frangesDel, Vector<Object> frangesAdd, int quatrimestre) {
        Statement stmt=null;
        Object[][] horari=null;
        franjaHoraria aux;
        int i;
        String union = "";
        professor x=(professor) p;
        try {
            if (!frangesAdd.isEmpty()) {
                if (frangesAdd.size()>1) {
                    for (i=1;i<frangesAdd.size();i++) {
                        union+=" union all select ?,?,?";
                    }
                }
                String sql="insert ignore into t_horaris_professors(t_professor_id,t_franja_horaria_id,t_quatrimestre) select ?,?,?"+union;
                PreparedStatement pStmt=con.getConn().prepareStatement(sql);
                for (i=0;i<frangesAdd.size();i++) {
                    pStmt.setInt(i*3+1, x.getId());
                    if (frangesAdd.elementAt(i) instanceof franjaHoraria) pStmt.setInt(i*3+2, ((franjaHoraria)frangesAdd.elementAt(i)).getId());
                    else pStmt.setInt(i*3+2, (Integer)frangesAdd.elementAt(i));
                    pStmt.setInt(i*3+3, quatrimestre);
                }
                int rs=pStmt.executeUpdate();
             }
            union="";
            if (!frangesDel.isEmpty()) {
                if (frangesDel.size()>1) {
                    for (i=1;i<frangesDel.size();i++) {
                        union+=" or (t_professor_id=? and t_franja_horaria_id=? and t_quatrimestre=?)";
                    }
                }
                String sql2="delete from t_horaris_professors where (t_professor_id=? and t_franja_horaria_id=? and t_quatrimestre=?)"+union;
                PreparedStatement pStmt2=con.getConn().prepareStatement(sql2);
                for (i=0;i<frangesDel.size();i++) {
                    pStmt2.setInt(i*3+1, x.getId());
                    if (frangesDel.elementAt(i) instanceof franjaHoraria ) pStmt2.setInt(i*3+2, ((franjaHoraria)frangesDel.elementAt(i)).getId());
                    else pStmt2.setInt(i*3+2, (Integer)frangesDel.elementAt(i));
                    pStmt2.setInt(i*3+3, quatrimestre);
                }
                int rs=pStmt2.executeUpdate();
            }

        } catch (SQLException ex) {
            Logger.getLogger(bdd_professors.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
