/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package bdd;

import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.util.logging.Level;
import java.util.logging.Logger;
import objectes.assignaturaTipologiaGrup;
import objectes.professor;
import java.sql.ResultSet;
import java.sql.Statement;

/**
 *
 * @author z0rskrab
 */
public class bdd_presolucions {
     public static Object[] selectAll(connect con) {
        Statement stmt=null;
        Object[] assignatures=null;
        assignaturaTipologiaGrup aux;
        try {
            String sql="select * from t_presolucions, t_assignatures_tipologia_grup, t_assignatures where t_presolucions.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_presolucions.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_presolucions.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_assignatures.t_assignatura_id=t_presolucions.t_assignatura_id";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            assignatures=new Object[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),rs.getString("t_grup_nom"));
                assignatures[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_presolucions.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignatures;
    }

    public static Object[] selectAll(connect con, professor p) {
        Statement stmt=null;
        Object[] assignatures=null;
        assignaturaTipologiaGrup aux;
        try {
            String sql="select * from t_presolucions, t_assignatures_tipologia_grup, t_assignatures where t_presolucions.t_assignatura_id=t_assignatures_tipologia_grup.t_assignatura_id and t_presolucions.t_tipologia_id=t_assignatures_tipologia_grup.t_tipologia_id and t_presolucions.t_grup_id=t_assignatures_tipologia_grup.t_grup_id and t_assignatures.t_assignatura_id=t_presolucions.t_assignatura_id and t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, p.getId());
            ResultSet rs=pStmt.executeQuery();
            rs.last();
            int nreg=rs.getRow();
            assignatures=new Object[nreg];
            rs.beforeFirst();
            int count=0;
            while (rs.next()) {
                aux=new assignaturaTipologiaGrup(rs.getInt("t_assignatura_id"),rs.getString("t_assignatura_nom"),rs.getInt("t_tipologia_id"),rs.getInt("t_grup_id"),rs.getString("t_grup_nom"));
                assignatures[count++]=aux;
            }
            rs.close();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_presolucions.class.getName()).log(Level.SEVERE, null, ex);
        }

        return assignatures;
    }

    public static boolean insert(connect con, assignaturaTipologiaGrup atg, professor p) {
        try {
            String sql="insert into t_presolucions(t_assignatura_id,t_tipologia_id, t_grup_id,t_professor_id) values(?,?,?,?)";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, atg.getId());
            pStmt.setInt(2, atg.getTipologia());
            pStmt.setInt(3, atg.getGrup());
            pStmt.setInt(4, p.getId());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }
    
    public static boolean delete(connect con, assignaturaTipologiaGrup atg, professor p) {
        try {
            String sql="delete from t_presolucions where t_assignatura_id=? and t_tipologia_id=? and t_grup_id=? and t_professor_id=?";
            PreparedStatement pStmt=con.getConn().prepareStatement(sql);
            pStmt.setInt(1, atg.getId());
            pStmt.setInt(2, atg.getTipologia());
            pStmt.setInt(3, atg.getGrup());
            pStmt.setInt(4, p.getId());
            int rs=pStmt.executeUpdate();
        } catch (SQLException ex) {
            Logger.getLogger(bdd_assignatures.class.getName()).log(Level.SEVERE, null, ex);
            return false;
        }
        return true;
    }
}
