/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * MantenirProfessors.java
 *
 * Created on 05/03/2011, 18:47:49
 */

package gui;

import control.ctrl_capacitacions;
import control.ctrl_franja_horaries;
import control.ctrl_professors;
import java.sql.SQLException;
import java.util.Arrays;
import java.util.List;
import java.util.Vector;
import java.util.logging.Level;
import java.util.logging.Logger;
import objectes.professor;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JOptionPane;

/**
 *
 * @author z0rskrab
 */
public class MantenirProfessors extends javax.swing.JDialog {

    boolean esNou;
    int idProfessor;
    /** Creates new form MantenirProfessors */
    public MantenirProfessors(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        idProfessor=-1;
        int i;
        DefaultComboBoxModel comboMin = new DefaultComboBoxModel();
        DefaultComboBoxModel comboMax=new DefaultComboBoxModel();
        for (i=0;i<50;i++) {
            comboMin.addElement(new Integer(i));
            comboMax.addElement(new Integer(i));
        }

        cboxMinCredits.setModel(comboMin);
        cboxMaxCredits.setModel(comboMax);
        cboxMinCredits.setSelectedIndex(0);
        cboxMaxCredits.setSelectedIndex(49);
    }

    public MantenirProfessors(java.awt.Frame parent, boolean modal, professor p) {
        super(parent, modal);
        initComponents();
        idProfessor=p.getId();
        txtnom.setText(p.getNom());
        txtcognoms.setText(p.getCognoms());
        DefaultComboBoxModel comboMin = new DefaultComboBoxModel();
        DefaultComboBoxModel comboMax=new DefaultComboBoxModel();
        int i;
        for (i=0;i<50;i++) {
            comboMin.addElement(new Integer(i));
            comboMax.addElement(new Integer(i));
        }

        cboxMinCredits.setModel(comboMin);
        cboxMaxCredits.setModel(comboMax);

        if (idProfessor>0) {
            cboxMinCredits.setSelectedIndex(p.getMinCredits());
            cboxMaxCredits.setSelectedIndex(p.getMaxCredits());
            btnAfegir.setText("Actualitzar");
        } else {
            cboxMinCredits.setSelectedIndex(0);
            cboxMaxCredits.setSelectedIndex(49);
            btnAfegir.setText("Afegir");
        }
    }
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        txtnom = new javax.swing.JTextField();
        lblnom = new javax.swing.JLabel();
        lblcognoms = new javax.swing.JLabel();
        txtcognoms = new javax.swing.JTextField();
        btnAfegir = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();
        chkProfCap = new javax.swing.JCheckBox();
        chkProfHoraris = new javax.swing.JCheckBox();
        jLabel1 = new javax.swing.JLabel();
        cboxMinCredits = new javax.swing.JComboBox();
        jLabel2 = new javax.swing.JLabel();
        cboxMaxCredits = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setName("Form"); // NOI18N

        org.jdesktop.application.ResourceMap resourceMap = org.jdesktop.application.Application.getInstance(gui.ProvaApp.class).getContext().getResourceMap(MantenirProfessors.class);
        txtnom.setText(resourceMap.getString("txtnom.text")); // NOI18N
        txtnom.setName("txtnom"); // NOI18N

        lblnom.setText(resourceMap.getString("lblnom.text")); // NOI18N
        lblnom.setName("lblnom"); // NOI18N

        lblcognoms.setText(resourceMap.getString("lblcognoms.text")); // NOI18N
        lblcognoms.setName("lblcognoms"); // NOI18N

        txtcognoms.setText(resourceMap.getString("txtcognoms.text")); // NOI18N
        txtcognoms.setName("txtcognoms"); // NOI18N

        btnAfegir.setText(resourceMap.getString("btnAfegir.text")); // NOI18N
        btnAfegir.setName("btnAfegir"); // NOI18N
        btnAfegir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAfegirActionPerformed(evt);
            }
        });

        btnCancel.setText(resourceMap.getString("btnCancel.text")); // NOI18N
        btnCancel.setName("btnCancel"); // NOI18N
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        chkProfCap.setText(resourceMap.getString("chkProfCap.text")); // NOI18N
        chkProfCap.setName("chkProfCap"); // NOI18N

        chkProfHoraris.setText(resourceMap.getString("chkProfHoraris.text")); // NOI18N
        chkProfHoraris.setName("chkProfHoraris"); // NOI18N

        jLabel1.setText(resourceMap.getString("jLabel1.text")); // NOI18N
        jLabel1.setName("jLabel1"); // NOI18N

        cboxMinCredits.setName("cboxMinCredits"); // NOI18N

        jLabel2.setText(resourceMap.getString("jLabel2.text")); // NOI18N
        jLabel2.setName("jLabel2"); // NOI18N

        cboxMaxCredits.setName("cboxMaxCredits"); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addContainerGap()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblnom)
                            .addComponent(lblcognoms))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtnom, javax.swing.GroupLayout.DEFAULT_SIZE, 350, Short.MAX_VALUE)
                            .addComponent(txtcognoms, javax.swing.GroupLayout.DEFAULT_SIZE, 350, Short.MAX_VALUE)))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(106, 106, 106)
                        .addComponent(btnAfegir)
                        .addGap(61, 61, 61)
                        .addComponent(btnCancel)))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chkProfHoraris, javax.swing.GroupLayout.DEFAULT_SIZE, 431, Short.MAX_VALUE)
                .addGap(12, 12, 12))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(chkProfCap, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(16, 16, 16))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboxMinCredits, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(cboxMaxCredits, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(160, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(txtnom, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txtcognoms, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(lblnom)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblcognoms)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(cboxMinCredits, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2)
                    .addComponent(cboxMaxCredits, javax.swing.GroupLayout.PREFERRED_SIZE, 18, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 8, Short.MAX_VALUE)
                .addComponent(chkProfCap)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(chkProfHoraris)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btnCancel)
                    .addComponent(btnAfegir))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
            this.dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    private void btnAfegirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAfegirActionPerformed
            ctrl_professors x = new ctrl_professors();
            ctrl_capacitacions c=new ctrl_capacitacions();
            ctrl_franja_horaries f=new ctrl_franja_horaries();
            if (cboxMaxCredits.getSelectedIndex()>=cboxMinCredits.getSelectedIndex()) {
                if (idProfessor>0) {
                    professor p = new professor(idProfessor, txtnom.getText(),txtcognoms.getText());
                    p.setMinCredits((Integer)cboxMinCredits.getSelectedItem());
                    p.setMaxCredits((Integer)cboxMaxCredits.getSelectedItem());
                    x.updateProfessor(p);
                    if (chkProfCap.isSelected()) {
                        try {
                            c.addProfessor(p);
                        } catch (SQLException ex) {
                            Logger.getLogger(MantenirProfessors.class.getName()).log(Level.SEVERE, null, ex);
                        }
                    }
                    if (chkProfHoraris.isSelected()) {
                            Object[] franges=f.selectAllFranges();
                            List list_franges=Arrays.asList(franges);
                            Vector frangesAdd=new Vector(list_franges);
                            f.actualitzarHoraris(p, new Vector(), frangesAdd, 1);
                            f.actualitzarHoraris(p, new Vector(), frangesAdd, 2);
                    }
                } else {
                    professor p = new professor(txtnom.getText(),txtcognoms.getText());
                    p.setMinCredits((Integer)cboxMinCredits.getSelectedItem());
                    p.setMaxCredits((Integer)cboxMaxCredits.getSelectedItem());
                    x.insertProfessor(p);
                }
                this.dispose();
            } else {
                JOptionPane.showMessageDialog(this.getParent(),"El nombre màxim de crèdits no pot ser inferior al mínim", "Error MinMax Crèdits",JOptionPane.INFORMATION_MESSAGE);
            }           
    }//GEN-LAST:event_btnAfegirActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                MantenirProfessors dialog = new MantenirProfessors(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAfegir;
    private javax.swing.JButton btnCancel;
    private javax.swing.JComboBox cboxMaxCredits;
    private javax.swing.JComboBox cboxMinCredits;
    private javax.swing.JCheckBox chkProfCap;
    private javax.swing.JCheckBox chkProfHoraris;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel lblcognoms;
    private javax.swing.JLabel lblnom;
    private javax.swing.JTextField txtcognoms;
    private javax.swing.JTextField txtnom;
    // End of variables declaration//GEN-END:variables

}
