@echo off

rem --------------------------------------------------------------------------
rem Copyright (C) 2010-2011 The University of Melbourne and NICTA.
rem See the file COPYING for license information.
rem 
rem mzn2fzn.bat - Set the MiniZinc library search path and invoke mzn2fzn.
rem
rem --------------------------------------------------------------------------

setlocal

rem Work out where the mzn2fzn.bat file is installed and then use that
rem to derive the location of the MiniZinc library.
rem
set MZN_INSTALL_DIR="%~dp0\.."

rem Set the MiniZinc library search path.
rem
set MZN_STDLIB_DIR=%MZN_INSTALL_DIR%\lib\minizinc

rem Tell mzn2fzn to expect Windows-style paths.
rem
set MZN_WIN_PATH_HACK=yes

%MZN_INSTALL_DIR%\bin\private\mzn2fzn %*
